
/*  A Bison parser, made from dlx_dlx.yac
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	_ALIGN	257
#define	_ASCII	258
#define	_ASCIIZ	259
#define	_BYTE	260
#define	_BYTEZ	261
#define	_DATA	262
#define	_END	263
#define	_EQU	264
#define	_GLOBAL	265
#define	_ORG	266
#define	_SPACE	267
#define	_SKIP	268
#define	_START	269
#define	_TEXT	270
#define	_WORD	271
#define	Ampersand	272
#define	Bar	273
#define	CarriageReturn	274
#define	Circomflex	275
#define	Codop_rd_rs_rt	276
#define	Codop_rd_rt_rs	277
#define	Codop_rd_rt_sham	278
#define	Codop_rd_rs_imd	279
#define	Codop_rs_rt_labl	280
#define	Codop_od_rs	281
#define	Codop_rs	282
#define	Codop_rd_mem	283
#define	Codop_rt_mem	284
#define	Codop_rd_sspe	285
#define	Codop_dspe_rt	286
#define	Codop_rs_labl	287
#define	Codop_rd_imd	288
#define	Codop_labl	289
#define	Codop_imd	290
#define	Codop_n	291
#define	Colon	292
#define	Comma	293
#define	DoubleGreat	294
#define	DoubleLess	295
#define	Identifier	296
#define	IntegerRegister	297
#define	LeftParen	298
#define	Litteral	299
#define	Macro_n	300
#define	Macro_rd_longi	301
#define	Minus	302
#define	Plus	303
#define	RightParen	304
#define	Sharp	305
#define	Slash	306
#define	SpecialRegister	307
#define	Star	308
#define	String	309

#line 10 "dlx_dlx.yac"

#include <stdio.h>
#include MUT_H
#include LOG_H
#include BEH_H
#include "dlx_type.h"
#include "dlx_defs.h"
#include "dlx_yacc.h"

main (argc, argv)

int   argc   ;
char *argv [];

  {
  extern FILE  *yyin          ;
  extern FILE  *DLX_WRTFIL    ;
  extern FILE  *DLX_TXTFIL    ;
  extern FILE  *DLX_DATFIL    ;
  extern FILE  *DLX_SYMFIL    ;
  FILE         *fp_read       ;
  char          arg_flg [ 32] ;
  unsigned int  txt_siz       = 256;
  unsigned int  dat_siz       =  64;
  int           exit_val      =   1;
  int           asm_fil       =   0;
  int           txt_fil       =   0;
  int           dat_fil       =   0;
  int           i             ;
  char         *symbol_fil    ;
  char          arg_err       =   0;
  static int    call_nbr      =   0;

	/* ###------------------------------------------------------### */
	/*   initializations						*/
	/* ###------------------------------------------------------### */

  alliancebanner ("asm", "v0.7", "DLX Assembler", "1991...1999", ALC_V);

  mbkenv ();

  for (i=1 ; i<argc ; i++)
    arg_flg [i] = 0;

  if (DLX_HSHTAB == NULL)
    DLX_HSHTAB = beh_initab ();

	/* ###------------------------------------------------------### */
	/*   analyze the command line:					*/
	/*     - for each argument set a flag to 1 if recognized	*/
	/*     - find the last recognized option to identify the source	*/
	/*       and result files					*/
	/* ###------------------------------------------------------### */

  arg_flg [0] = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      {
      if (!strcmp (argv[i], "-textsize"))
        {
        sscanf (argv[i+1], "%u", &txt_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-datasize"))
        {
        sscanf (argv[i+1], "%u", &dat_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-symbol"))
        {
        DLX_SYMBOL    = 'y'       ;
        symbol_fil    = argv [i+1];
        arg_flg [i]   = 1         ;
        arg_flg [i+1] = 1         ;
        }

      if (!strcmp (argv[i], "-mips"))
        {
        DLX_ARCHIT  = DLX_MIPSDFN;
        arg_flg [i] = 1          ;
        }

      if (!strcmp (argv[i], "-dlxp"))
        {
        DLX_ARCHIT  = DLX_DLXPDFN;
        arg_flg [i] = 1          ;
        }
      }
    }

  for (i=(argc-1) ; i>0 ; i--)
    {
    if (arg_flg [i] == 1)
      break;
    }

  asm_fil       = i + 1;
  arg_flg [i+1] = 1    ;
  txt_fil       = i + 2;
  arg_flg [i+2] = 1    ;
  dat_fil       = i + 3;
  arg_flg [i+3] = 1    ;


	/* ###------------------------------------------------------### */
	/*   cases of errors on the command line:			*/
	/*     - a unrecognized argument				*/
	/*     - not enough arguments					*/
	/*     - too many arguments					*/
	/* ###------------------------------------------------------### */

  if ((argc > 11) || (argc < 4))
    arg_err = 1;

  if (dat_fil >= argc)
    arg_err = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      arg_err = 1;
    }

  if (arg_err == 1)
    {
    dlx_error (101, NULL);
    exit (1);
    }

	/* ###------------------------------------------------------### */
	/*   open source file (assembly) and result files (vhdl)	*/
	/* ###------------------------------------------------------### */

  if ((fp_read = fopen (argv [asm_fil], "r")) == NULL)
    {
    dlx_error (100, argv [asm_fil]);
    exit (1);
    }

  if ((DLX_TXTFIL = mbkfopen (argv[txt_fil], "vbe", WRITE_TEXT)) == NULL)
    {
    dlx_error (100, argv [txt_fil]);
    exit (1);
    }

  if ((DLX_DATFIL = mbkfopen (argv[dat_fil], "vbe", WRITE_TEXT)) == NULL)
    {
    dlx_error (100, argv [dat_fil]);
    exit (1);
    }

  if (DLX_SYMBOL == 'y')
    {
    if ((DLX_SYMFIL = fopen (symbol_fil, "w")) == NULL)
      {
      dlx_error (100, symbol_fil);
      exit (1);
      }
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the text address.	*/
	/* The address is a word (4 bytes) address			*/
	/* ###------------------------------------------------------### */

  txt_siz = (txt_siz >> 2) - 1;
  while (txt_siz != 0)
    {
    txt_siz = txt_siz >> 1;
    DLX_TXTSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the data address	*/
	/* ###------------------------------------------------------### */

  dat_siz -= 1;
  while (dat_siz != 0)
    {
    dat_siz = dat_siz >> 1;
    DLX_DATSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   call the assembly file parser (two passes):		*/
	/*	- set the address space (by default) to text		*/
	/*      - in the first pass identify labels			*/
	/*      - if no error has been found print the result files'	*/
	/*        header						*/
	/*      - translate insstructions in the second pass		*/
	/*      - print the result files' foot				*/
	/* ###------------------------------------------------------### */

  DLX_ADRSPC = 'T'       ;
  DLX_ADDRES = DLX_TXTADR;
  DLX_WRTFIL = DLX_TXTFIL;
  DLX_ADRSIZ = DLX_TXTSIZ;
  DLX_WRDSIZ = 4         ;

  DLX_PASNBR = 1  ;

  if (call_nbr != 0)
    yyrestart (yyin);

  yyin = fp_read;
  yyparse ();

  call_nbr++;

  if (DLX_ERRFLG == 0)
    {
    fclose (fp_read);
    fp_read = fopen (argv [asm_fil], "r");
    yyin    = fp_read;

    DLX_ADRSPC = 'T';
    DLX_ADDRES = DLX_TXTADR;
    DLX_WRTFIL = DLX_TXTFIL;
    DLX_ADRSIZ = DLX_TXTSIZ;
    DLX_WRDSIZ = 4;

    DLX_PASNBR = 2  ;
    DLX_LINNUM = 1  ;

    dlx_head (DLX_TXTFIL, argv [txt_fil], DLX_TXTSIZ, 4);
    dlx_head (DLX_DATFIL, argv [dat_fil], DLX_DATSIZ, 1);

    yyrestart (yyin);
    yyparse ();

    dlx_foot (DLX_TXTFIL, 4);
    dlx_foot (DLX_DATFIL, 1);

    exit_val = 0;

    }

	/* ###------------------------------------------------------### */
	/*   close source and result files				*/
	/* ###------------------------------------------------------### */

  fclose (fp_read);
  fclose (DLX_TXTFIL);
  fclose (DLX_DATFIL);
  if (DLX_SYMBOL == 'y')
    fclose (DLX_SYMFIL);

  exit (exit_val);
  }


#line 268 "dlx_dlx.yac"
typedef union
  {
  unsigned long  valu;
  struct immd    immd;
  char          *text;
  } YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		213
#define	YYFLAG		-32768
#define	YYNTBASE	56

#define YYTRANSLATE(x) ((unsigned)(x) <= 309 ? yytranslate[x] : 122)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     6,     9,    13,    16,    19,    20,    23,
    24,    26,    28,    30,    32,    34,    36,    38,    40,    42,
    45,    48,    51,    54,    57,    59,    61,    63,    65,    67,
    69,    71,    74,    77,    80,    83,    84,    86,    89,    92,
    95,    98,   101,   105,   107,   109,   111,   113,   115,   117,
   119,   121,   123,   125,   127,   129,   131,   133,   135,   137,
   139,   141,   148,   155,   160,   165,   168,   173,   176,   184,
   192,   200,   208,   215,   220,   225,   229,   232,   234,   235,
   237,   239,   241,   246,   248,   250,   251,   253,   255,   257,
   259,   261,   263,   267,   271,   275,   279,   283,   287,   289,
   291,   293,   295,   299,   304,   306,   308,   310,   312,   314,
   316,   318,   321,   323,   326,   328,   330,   332,   334,   336,
   337,   340
};

static const short yyrhs[] = {    57,
    73,     0,    58,     0,     0,    58,    59,     0,    60,    61,
   121,     0,    68,   121,     0,     1,   121,     0,     0,   119,
    38,     0,     0,    62,     0,    80,     0,    63,     0,    64,
     0,    65,     0,    66,     0,    67,     0,    77,     0,    76,
     0,    17,   104,     0,     6,   104,     0,     7,   104,     0,
     4,    55,     0,     5,    55,     0,    72,     0,    69,     0,
    79,     0,    71,     0,    78,     0,    75,     0,    70,     0,
     8,   103,     0,    16,   103,     0,    11,   119,     0,     3,
    45,     0,     0,    74,     0,     9,   120,     0,    15,   119,
     0,    13,    45,     0,    14,    45,     0,    12,   104,     0,
    42,    10,   104,     0,    81,     0,    99,     0,    97,     0,
    96,     0,    95,     0,    94,     0,    93,     0,    92,     0,
    90,     0,    91,     0,    88,     0,    89,     0,    86,     0,
    87,     0,    82,     0,    83,     0,    84,     0,    85,     0,
    22,   115,    39,   116,    39,   116,     0,    23,   115,    39,
   116,    39,   116,     0,    32,   117,    39,   116,     0,    31,
   115,    39,   118,     0,    27,   116,     0,    27,   115,    39,
   116,     0,    28,   116,     0,    25,   115,    39,   116,    39,
    98,   104,     0,    24,   115,    39,   116,    39,    98,   104,
     0,    29,   115,    39,   102,    44,   116,    50,     0,    30,
   116,    39,   102,    44,   116,    50,     0,    26,   116,    39,
   116,    39,   104,     0,    33,   116,    39,   104,     0,    34,
   115,    39,   104,     0,    36,    98,   104,     0,    35,   104,
     0,    37,     0,     0,    51,     0,   100,     0,   101,     0,
    47,   115,    39,   104,     0,    46,     0,   104,     0,     0,
   104,     0,   105,     0,   106,     0,   107,     0,   108,     0,
   111,     0,   105,   113,   111,     0,   111,   110,   111,     0,
   106,    54,   111,     0,   111,   112,   111,     0,   107,   112,
   111,     0,   111,   109,   111,     0,    41,     0,    40,     0,
    54,     0,    52,     0,    44,   104,    50,     0,    48,    44,
   111,    50,     0,   114,     0,    19,     0,    18,     0,    21,
     0,    49,     0,    48,     0,    45,     0,    48,    45,     0,
    42,     0,    48,    42,     0,    43,     0,    43,     0,    53,
     0,    53,     0,    42,     0,     0,   120,   121,     0,    20,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   384,   389,   393,   394,   399,   402,   404,   409,   410,   435,
   436,   446,   459,   461,   463,   465,   467,   469,   474,   482,
   496,   511,   529,   542,   561,   562,   563,   564,   565,   566,
   567,   571,   603,   635,   640,   667,   668,   672,   677,   682,
   690,   698,   713,   743,   745,   750,   752,   754,   756,   758,
   760,   762,   764,   766,   768,   770,   772,   774,   776,   778,
   780,   785,   806,   827,   846,   865,   879,   898,   915,   940,
   965,   990,  1015,  1047,  1077,  1099,  1120,  1145,  1161,  1162,
  1166,  1168,  1173,  1211,  1232,  1237,  1242,  1247,  1249,  1251,
  1253,  1258,  1260,  1282,  1301,  1320,  1343,  1369,  1391,  1393,
  1398,  1400,  1405,  1411,  1419,  1424,  1426,  1428,  1433,  1435,
  1440,  1445,  1451,  1459,  1471,  1476,  1481,  1486,  1491,  1496,
  1497,  1502
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","_ALIGN",
"_ASCII","_ASCIIZ","_BYTE","_BYTEZ","_DATA","_END","_EQU","_GLOBAL","_ORG","_SPACE",
"_SKIP","_START","_TEXT","_WORD","Ampersand","Bar","CarriageReturn","Circomflex",
"Codop_rd_rs_rt","Codop_rd_rt_rs","Codop_rd_rt_sham","Codop_rd_rs_imd","Codop_rs_rt_labl",
"Codop_od_rs","Codop_rs","Codop_rd_mem","Codop_rt_mem","Codop_rd_sspe","Codop_dspe_rt",
"Codop_rs_labl","Codop_rd_imd","Codop_labl","Codop_imd","Codop_n","Colon","Comma",
"DoubleGreat","DoubleLess","Identifier","IntegerRegister","LeftParen","Litteral",
"Macro_n","Macro_rd_longi","Minus","Plus","RightParen","Sharp","Slash","SpecialRegister",
"Star","String","dlx_assembly_prog","assembly_instructions","..an_assembly_instruction..",
"an_assembly_instruction",".a_label.",".unlabeled_assembly_instruction.","mem_alloc_directive",
"word_alloc","byte_alloc","bytez_alloc","ascii_alloc","asciiz_alloc","unlabeled_pseudo_instruction",
"data_pseudo_inst","text_pseudo_inst","global_pseudo_inst","align_pseudo_inst",
".end_pseudo_inst.","end_pseudo_inst","start_pseudo_inst","space_pseudo_inst",
"skip_pseudo_inst","org_pseudo_inst","equ_pseudo_inst","effective_instruction",
"dlx_instruction","format_rd_rs_rt","format_rd_rt_rs","format_dspe_rt","format_rd_sspe",
"format_.rd.rs","format_rs","format_rd_rs_imd","format_rd_rt_sham","format_rd_mem",
"format_rt_mem","format_rs_rt_labl","format_rs_labl","format_rd_imd","format_imd",
"format_labl","format_n",".sharp.","macro_instruction","macro_ri","macro_n",
"offset",".immediate.","immediate","expr..addop__expr..","expr__mulop__expr..mulop__expr..",
"expr__logop__expr..logop__expr..","expr__shfop__expr","shift_operator","mul_div_operator",
"expression","logical_operator","adding_operator","term","destination_register",
"source_register","special_dest_reg","special_sour_reg","label","..CR..","CarriageReturn_ERR", NULL
};
#endif

static const short yyr1[] = {     0,
    56,    57,    58,    58,    59,    59,    59,    60,    60,    61,
    61,    61,    62,    62,    62,    62,    62,    62,    62,    63,
    64,    65,    66,    67,    68,    68,    68,    68,    68,    68,
    68,    69,    70,    71,    72,    73,    73,    74,    75,    76,
    77,    78,    79,    80,    80,    81,    81,    81,    81,    81,
    81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
    81,    82,    83,    84,    85,    86,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    98,
    99,    99,   100,   101,   102,   103,   103,   104,   104,   104,
   104,   105,   105,   106,   106,   107,   107,   108,   109,   109,
   110,   110,   111,   111,   111,   112,   112,   112,   113,   113,
   114,   114,   114,   114,   115,   116,   117,   118,   119,   120,
   120,   121
};

static const short yyr2[] = {     0,
     2,     1,     0,     2,     3,     2,     2,     0,     2,     0,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
     1,     2,     2,     2,     2,     0,     1,     2,     2,     2,
     2,     2,     3,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     6,     6,     4,     4,     2,     4,     2,     7,     7,
     7,     7,     6,     4,     4,     3,     2,     1,     0,     1,
     1,     1,     4,     1,     1,     0,     1,     1,     1,     1,
     1,     1,     3,     3,     3,     3,     3,     3,     1,     1,
     1,     1,     3,     4,     1,     1,     1,     1,     1,     1,
     1,     2,     1,     2,     1,     1,     1,     1,     1,     0,
     2,     1
};

static const short yydefact[] = {     3,
    36,     0,   120,     1,    37,     0,     0,    86,     0,     0,
     0,    86,   119,     4,    10,     0,    26,    31,    28,    25,
    30,    29,    27,     0,    38,   122,     7,    35,   113,     0,
   111,     0,    32,    87,    88,    89,    90,    91,    92,   105,
   119,    34,    42,    39,    33,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    79,    78,    84,
     0,     0,    11,    13,    14,    15,    16,    17,    19,    18,
    12,    44,    58,    59,    60,    61,    56,    57,    54,    55,
    52,    53,    51,    50,    49,    48,    47,    46,    45,    81,
    82,     6,     9,   121,     0,   114,     0,   112,   110,   109,
     0,     0,   107,   106,   108,     0,   100,    99,   102,   101,
     0,     0,     0,    43,    23,    24,    21,    22,    40,    41,
    20,   115,     0,     0,     0,     0,   116,     0,   115,     0,
    66,    68,     0,     0,     0,   117,     0,     0,     0,    77,
    80,     0,     0,     5,   103,     0,    93,    95,    97,    98,
    94,    96,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    76,     0,   104,     0,     0,     0,
     0,     0,    67,     0,    85,     0,   118,    65,    64,    74,
    75,    83,     0,     0,    79,    79,     0,     0,     0,    62,
    63,     0,     0,    73,     0,     0,    70,    69,    71,    72,
     0,     0,     0
};

static const short yydefgoto[] = {   211,
     1,     2,    14,    15,    72,    73,    74,    75,    76,    77,
    78,    16,    17,    18,    19,    20,     4,     5,    21,    79,
    80,    22,    23,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,   152,    99,   100,   101,   184,    33,    34,    35,    36,
    37,    38,   121,   122,    39,   116,   111,    40,   133,   138,
   147,   188,    24,    25,    27
};

static const short yypact[] = {-32768,
     0,   194,-32768,-32768,-32768,    -7,   -26,   -34,   -12,   -34,
   -12,   -34,    19,-32768,    41,    -7,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    -4,    -7,-32768,-32768,-32768,-32768,   -34,
-32768,   -17,-32768,-32768,   -43,   -19,    23,-32768,    -3,-32768,
-32768,-32768,-32768,-32768,-32768,   -34,    -5,    -2,   -34,   -34,
     7,    11,   -34,    18,    18,    18,    18,    36,    37,    36,
    18,    36,    18,    28,    36,    18,   -34,    31,-32768,-32768,
    18,    -7,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    33,-32768,   -34,-32768,-32768,-32768,
   -34,   -34,-32768,-32768,-32768,   -34,-32768,-32768,-32768,-32768,
   -34,   -34,   -34,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    45,    46,    47,    50,-32768,    52,    70,    53,
-32768,-32768,    54,    55,    57,-32768,    58,    59,    60,-32768,
-32768,   -34,    61,-32768,-32768,    66,-32768,-32768,-32768,-32768,
-32768,-32768,    36,    36,    36,    36,    36,    36,   -34,   -34,
    42,    36,   -34,   -34,-32768,   -34,-32768,    62,    63,    64,
    65,    79,-32768,    76,-32768,    77,-32768,-32768,-32768,-32768,
-32768,-32768,    36,    36,    31,    31,   -34,    36,    36,-32768,
-32768,   -34,   -34,-32768,    73,    74,-32768,-32768,-32768,-32768,
   125,   126,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,  -172,-32768,-32768,-32768,   -42,   117,   -10,-32768,-32768,
-32768,-32768,-32768,-32768,   -90,    91,-32768,-32768,    56,   -58,
-32768,-32768,    51,-32768,   -13
};


#define	YYLAST		241


static const short yytable[] = {    43,
   141,   142,   102,   144,   109,   110,   148,    29,     3,    30,
    31,   104,    26,    32,   113,   114,   156,   115,    28,   105,
   157,   158,   202,   203,   106,   159,   107,   108,    46,    41,
   160,   161,   162,   103,   112,   124,   117,   118,   127,   128,
   113,   114,   131,   115,    47,    48,    49,    50,   119,   125,
   120,   129,   126,    51,    52,   130,   150,    53,   154,    42,
   132,    44,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,   137,   139,
   146,   151,   155,   163,   164,   165,    70,    71,   166,  -116,
   167,   168,   169,   170,   187,   171,   172,   173,   174,   176,
   193,   194,   195,   196,   178,   179,   180,   181,   182,   183,
   134,   135,   136,   189,   140,   177,   143,   197,   145,   198,
   199,   149,   209,   210,   212,   213,   153,   186,    45,   123,
     0,     0,     0,     0,   200,   201,     0,     0,     0,   205,
   206,   175,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   185,   185,
     0,     0,   190,   191,     0,   192,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   204,     0,     0,     0,
     0,   207,   208,    -2,     6,     0,     7,    -8,    -8,    -8,
    -8,     8,    -2,     0,     9,    10,    -8,    -8,    11,    12,
    -8,     0,     0,    -8,     0,    -8,    -8,    -8,    -8,    -8,
    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
    -8,     0,     0,     0,     0,    13,     0,     0,     0,    -8,
    -8
};

static const short yycheck[] = {    10,
    59,    60,    16,    62,    48,    49,    65,    42,     9,    44,
    45,    25,    20,    48,    18,    19,   107,    21,    45,    30,
   111,   112,   195,   196,    42,   116,    44,    45,    10,    42,
   121,   122,   123,    38,    54,    46,    40,    41,    49,    50,
    18,    19,    53,    21,     4,     5,     6,     7,    52,    55,
    54,    45,    55,    13,    14,    45,    67,    17,    72,     9,
    43,    11,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    43,    43,
    53,    51,    50,    39,    39,    39,    46,    47,    39,    20,
    39,    39,    39,    39,    53,    39,    39,    39,    39,    39,
    39,    39,    39,    39,   163,   164,   165,   166,   167,   168,
    55,    56,    57,   172,    59,    50,    61,    39,    63,    44,
    44,    66,    50,    50,     0,     0,    71,   170,    12,    39,
    -1,    -1,    -1,    -1,   193,   194,    -1,    -1,    -1,   198,
   199,   152,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,   170,
    -1,    -1,   173,   174,    -1,   176,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   197,    -1,    -1,    -1,
    -1,   202,   203,     0,     1,    -1,     3,     4,     5,     6,
     7,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
    17,    -1,    -1,    20,    -1,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,    46,
    47
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/freeware/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/freeware/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 9:
#line 412 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the label is unique.	*/
		/* Save its address in the dictionary and flag it as a	*/
		/* label.						*/
		/* ###----------------------------------------------### */

		if (DLX_PASNBR == 1)
		  {
		  if (beh_chktab (DLX_HSHTAB, yyvsp[-1].text, NULL, 0) == 0)
		    {
		    beh_addtab (DLX_HSHTAB, yyvsp[-1].text, NULL, 0, 'l'       );
		    beh_addtab (DLX_HSHTAB, yyvsp[-1].text, NULL, 7, DLX_ADDRES);
		    if (DLX_SYMBOL == 'y')
		      dlx_symbol (yyvsp[-1].text);
		    }
		  else
		    dlx_error (3, NULL);
		  }
		;
    break;}
case 11:
#line 437 "dlx_dlx.yac"
{
		if ((DLX_PASNBR == 2) && (yyvsp[0].immd.flag == 0))
		  dlx_error (4, NULL);

		if (DLX_PASNBR == 2)
		  dlx_print (yyvsp[0].immd.valu);

		DLX_ADDRES += yyvsp[0].immd.valu;
		;
    break;}
case 12:
#line 447 "dlx_dlx.yac"
{
		if ((DLX_PASNBR == 2) && (yyvsp[0].immd.flag == 0))
		  dlx_error (4, NULL);

		if (DLX_PASNBR == 2)
		  dlx_print (yyvsp[0].immd.valu);

		DLX_ADDRES += yyvsp[0].immd.valu;
		;
    break;}
case 13:
#line 460 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 14:
#line 462 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 15:
#line 464 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 16:
#line 466 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 17:
#line 468 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 18:
#line 470 "dlx_dlx.yac"
{
		yyval.immd.valu = 0  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 19:
#line 475 "dlx_dlx.yac"
{
		yyval.immd.valu = 0  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 20:
#line 484 "dlx_dlx.yac"
{
		DLX_BYTTAB [0] = yyvsp[0].immd.valu >> 24;
		DLX_BYTTAB [1] = yyvsp[0].immd.valu >> 16;
		DLX_BYTTAB [2] = yyvsp[0].immd.valu >>  8;
		DLX_BYTTAB [3] = yyvsp[0].immd.valu      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 21:
#line 498 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   initialize a byte address with a value		*/
		/* ###----------------------------------------------### */

		DLX_BYTTAB [0] = yyvsp[0].immd.valu;

		yyval.immd.valu = 1      ;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 22:
#line 513 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   initialize a byte table with zeros			*/
		/* ###----------------------------------------------### */

		unsigned int i;

		for (i=0; i<yyvsp[0].immd.valu ; i++)
		  DLX_BYTTAB [i] = 0x00;

		yyval.immd.valu = yyvsp[0].immd.valu;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 23:
#line 531 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* ###----------------------------------------------### */

		yyval.immd.valu = dlx_strtobin (yyvsp[0].text, DLX_BYTTAB);
		yyval.immd.flag = 'n';
		;
    break;}
case 24:
#line 544 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* followed by a null character				*/
		/* ###----------------------------------------------### */

		unsigned int size;

		size = dlx_strtobin (yyvsp[0].text, DLX_BYTTAB);
		DLX_BYTTAB [size] = '\0';

		yyval.immd.valu = size + 1;
		yyval.immd.flag = 'n';
		;
    break;}
case 32:
#line 573 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   if the current region is the 'text region', switch	*/
		/* to the 'data region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (DLX_ADRSPC == 'T')
		  {
		  DLX_TXTADR = DLX_ADDRES;

		  DLX_ADDRES = DLX_DATADR;
		  DLX_WRTFIL = DLX_DATFIL;
		  DLX_ADRSIZ = DLX_DATSIZ;
		  DLX_WRDSIZ = 1;
		  DLX_ADRSPC = 'D';
		  }

		if (yyvsp[0].immd.flag == 'i')
		  DLX_ADDRES = yyvsp[0].immd.valu;
		else
		  {
		  if (yyvsp[0].immd.flag != 'n')
		    dlx_error (4, NULL);
		  }
		;
    break;}
case 33:
#line 605 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   if the current region is the 'data region', switch	*/
		/* to the 'text region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (DLX_ADRSPC == 'D')
		  {
		  DLX_DATADR = DLX_ADDRES;

		  DLX_ADDRES = DLX_TXTADR;
		  DLX_WRTFIL = DLX_TXTFIL;
		  DLX_ADRSIZ = DLX_TXTSIZ;
		  DLX_WRDSIZ = 4;
		  DLX_ADRSPC = 'T';
		  }

		if (yyvsp[0].immd.flag == 'i')
		  DLX_ADDRES = yyvsp[0].immd.valu;
		else
		  {
		  if (yyvsp[0].immd.flag != 'n')
		    dlx_error (4, NULL);
		  }
		;
    break;}
case 35:
#line 642 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   align the current address				*/
		/* ###----------------------------------------------### */

		switch (yyvsp[0].valu)
		  {
		  case 1:
		    break;
		  case 2:
		    DLX_ADDRES = (DLX_ADDRES + 1) & 0xfffffffe;
		    break;
		  case 4:
		    DLX_ADDRES = (DLX_ADDRES + 3) & 0xfffffffc;
		    break;
		  case 8:
		    DLX_ADDRES = (DLX_ADDRES + 7) & 0xfffffff8;
		    break;
		  default:
		    dlx_error (4, NULL);
		  }
		;
    break;}
case 40:
#line 684 "dlx_dlx.yac"
{
		DLX_ADDRES += yyvsp[0].valu;
		;
    break;}
case 41:
#line 692 "dlx_dlx.yac"
{
		DLX_ADDRES += yyvsp[0].valu;
		;
    break;}
case 42:
#line 700 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   define the first address (must be an immediate)	*/
		/* ###----------------------------------------------### */

		if (yyvsp[0].immd.flag == 'i')
		  DLX_ADDRES = yyvsp[0].immd.valu;
		else
		  dlx_error (4, NULL);
		;
    break;}
case 43:
#line 716 "dlx_dlx.yac"
{
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the identifier has	*/
		/* not been defined ealier.				*/
		/*   Save its value in the dictionary and flag it as	*/
		/* an immediate.					*/
		/* ###----------------------------------------------### */

		if (DLX_PASNBR == 1)
		  {
		  if (yyvsp[0].immd.flag == 'i')
		    {
		    if (beh_chktab (DLX_HSHTAB, yyvsp[-2].text, NULL, 0) == 0)
		      {
		      beh_addtab (DLX_HSHTAB, yyvsp[-2].text, NULL, 0, 'i'    );
		      beh_addtab (DLX_HSHTAB, yyvsp[-2].text, NULL, 7, yyvsp[0].immd.valu);
		      }
		    else
		      dlx_error (3, NULL);
		    }
		  else
		    dlx_error (4, NULL);
		  }
		;
    break;}
case 44:
#line 744 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 45:
#line 746 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 46:
#line 751 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 47:
#line 753 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 48:
#line 755 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 49:
#line 757 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 50:
#line 759 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 51:
#line 761 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 52:
#line 763 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 53:
#line 765 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 54:
#line 767 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 55:
#line 769 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 56:
#line 771 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 57:
#line 773 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 58:
#line 775 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 59:
#line 777 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 60:
#line 779 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 61:
#line 781 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 62:
#line 791 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-5].valu | (yyvsp[-2].valu << 21) | (yyvsp[0].valu << 16) | (yyvsp[-4].valu << 11);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = 'n';
		;
    break;}
case 63:
#line 812 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-5].valu | (yyvsp[0].valu << 21) | (yyvsp[-2].valu << 16) | (yyvsp[-4].valu << 11);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 64:
#line 831 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-3].valu | (yyvsp[0].valu << 16) | (yyvsp[-2].valu << 11);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = 'n';
		;
    break;}
case 65:
#line 850 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-3].valu | (yyvsp[0].valu << 16) | (yyvsp[-2].valu << 11);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = 'n';
		;
    break;}
case 66:
#line 867 "dlx_dlx.yac"
{
		unsigned long inst = 0x0000f800;

		inst           |= yyvsp[-1].valu | (yyvsp[0].valu << 21);
		DLX_BYTTAB [0]  = inst >> 24;
		DLX_BYTTAB [1]  = inst >> 16;
		DLX_BYTTAB [2]  = inst >>  8;
		DLX_BYTTAB [3]  = inst      ;

		yyval.immd.valu = 4  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 67:
#line 883 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-3].valu | (yyvsp[0].valu << 21) | (yyvsp[-2].valu << 11);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 68:
#line 900 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[-1].valu | (yyvsp[0].valu << 21);
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = 'n';
		;
    break;}
case 69:
#line 922 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & yyvsp[0].immd.valu;
		inst = yyvsp[-6].valu | (yyvsp[-3].valu << 21) | (yyvsp[-5].valu << 16) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 70:
#line 947 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000001f & yyvsp[0].immd.valu;
		inst = yyvsp[-6].valu | (yyvsp[-3].valu << 16) | (yyvsp[-5].valu << 11) | (imd << 6);

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 71:
#line 972 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & yyvsp[-3].immd.valu;
		inst = yyvsp[-6].valu | (yyvsp[-1].valu << 21) | (yyvsp[-5].valu << 16) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[-3].immd.flag;
		;
    break;}
case 72:
#line 997 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & yyvsp[-3].immd.valu;
		inst = yyvsp[-6].valu | (yyvsp[-1].valu << 21) | (yyvsp[-5].valu << 16) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[-3].immd.flag;
		;
    break;}
case 73:
#line 1021 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if (yyvsp[0].immd.flag == 'l')
		  imd = yyvsp[0].immd.valu - DLX_ADDRES - 4;
		else
		  {
		  if (DLX_PASNBR == 2)
		    dlx_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = yyvsp[-5].valu | (yyvsp[-4].valu << 21) | (yyvsp[-2].valu << 16) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4      ;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 74:
#line 1051 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if (yyvsp[0].immd.flag == 'l')
		  imd = yyvsp[0].immd.valu - DLX_ADDRES - 4;
		else
		  {
		  if (DLX_PASNBR == 2)
		    dlx_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = yyvsp[-3].valu | (yyvsp[-2].valu << 21) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 75:
#line 1081 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & yyvsp[0].immd.valu;
		inst = yyvsp[-3].valu | (yyvsp[-2].valu << 16) | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 76:
#line 1102 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & yyvsp[0].immd.valu;
		inst = yyvsp[-2].valu | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 77:
#line 1122 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if (yyvsp[0].immd.flag == 'l')
		  imd = yyvsp[0].immd.valu - DLX_ADDRES - 4;
		else
		  imd = yyvsp[0].immd.valu;

		imd  = 0x03ffffff & (imd >> 2);
		inst = yyvsp[-1].valu | imd;

		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = yyvsp[0].immd.flag;
		;
    break;}
case 78:
#line 1146 "dlx_dlx.yac"
{
		unsigned long inst = 0;

		inst           = yyvsp[0].valu;
		DLX_BYTTAB [0] = inst >> 24;
		DLX_BYTTAB [1] = inst >> 16;
		DLX_BYTTAB [2] = inst >>  8;
		DLX_BYTTAB [3] = inst      ;

		yyval.immd.valu = 4;
		yyval.immd.flag = 'n';
		;
    break;}
case 81:
#line 1167 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 82:
#line 1169 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 83:
#line 1177 "dlx_dlx.yac"
{
		unsigned long imd  = 0;
		unsigned long inst = 0;

		switch (yyvsp[-3].valu)
		  {
		  case _LOADI :
		    imd  = 0x0000ffff & (yyvsp[0].immd.valu >> 16);
		    inst = _LUI | (yyvsp[-2].valu << 16) | imd;

		    DLX_BYTTAB [0] = inst >> 24;
		    DLX_BYTTAB [1] = inst >> 16;
		    DLX_BYTTAB [2] = inst >>  8;
		    DLX_BYTTAB [3] = inst      ;

		    imd  = 0x0000ffff & yyvsp[0].immd.valu;
		    inst = _ORI | (yyvsp[-2].valu << 21) | (yyvsp[-2].valu << 16) | imd;

		    DLX_BYTTAB [4] = inst >> 24;
		    DLX_BYTTAB [5] = inst >> 16;
		    DLX_BYTTAB [6] = inst >>  8;
		    DLX_BYTTAB [7] = inst      ;

		    yyval.immd.valu = 8;
		    yyval.immd.flag = yyvsp[0].immd.flag;
		    break;

		  default:
		    dlx_error (5, NULL);
		  }
		;
    break;}
case 84:
#line 1212 "dlx_dlx.yac"
{
		switch (yyvsp[0].valu)
		  {
		  case _NOP :
		    DLX_BYTTAB [0] = 0x00;
		    DLX_BYTTAB [1] = 0x00;
		    DLX_BYTTAB [2] = 0x00;
		    DLX_BYTTAB [3] = 0x21;

		    yyval.immd.valu = 4;
		    yyval.immd.flag = 'n';
		    break;

		  default:
		    dlx_error (5, NULL);
		  }
		;
    break;}
case 85:
#line 1233 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 86:
#line 1238 "dlx_dlx.yac"
{
		yyval.immd.valu = 0  ;
		yyval.immd.flag = 'n';
		;
    break;}
case 87:
#line 1243 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 88:
#line 1248 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 89:
#line 1250 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 90:
#line 1252 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 91:
#line 1254 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 92:
#line 1259 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 93:
#line 1263 "dlx_dlx.yac"
{
		if (yyvsp[-1].valu == DLX_PLSDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu + yyvsp[0].immd.valu;
		else
		  yyval.immd.valu = yyvsp[-2].immd.valu - yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 94:
#line 1285 "dlx_dlx.yac"
{
		if (yyvsp[-1].valu == DLX_MULDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu * yyvsp[0].immd.valu;
		else
		  yyval.immd.valu = yyvsp[-2].immd.valu / yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 95:
#line 1304 "dlx_dlx.yac"
{
		yyval.immd.valu = yyvsp[-2].immd.valu * yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 96:
#line 1323 "dlx_dlx.yac"
{
		if (yyvsp[-1].valu == DLX_ORDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu | yyvsp[0].immd.valu;

		if (yyvsp[-1].valu == DLX_ANDDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu & yyvsp[0].immd.valu;

		if (yyvsp[-1].valu == DLX_XORDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu ^ yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 97:
#line 1346 "dlx_dlx.yac"
{
		if (yyvsp[-1].valu == DLX_ORDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu | yyvsp[0].immd.valu;

		if (yyvsp[-1].valu == DLX_ANDDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu & yyvsp[0].immd.valu;

		if (yyvsp[-1].valu == DLX_XORDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu ^ yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 98:
#line 1372 "dlx_dlx.yac"
{
		if (yyvsp[-1].valu == DLX_SHLDFN)
		  yyval.immd.valu = yyvsp[-2].immd.valu << yyvsp[0].immd.valu;
		else
		  yyval.immd.valu = yyvsp[-2].immd.valu >> yyvsp[0].immd.valu;

		if ((yyvsp[-2].immd.flag == 0) || (yyvsp[0].immd.flag == 0))
		  yyval.immd.flag = 0;
		else
		  {
		  if ((yyvsp[-2].immd.flag == 'l') || (yyvsp[0].immd.flag == 'l'))
		    yyval.immd.flag = 'l';
		  else
		    yyval.immd.flag = 'i';
		  }
		;
    break;}
case 99:
#line 1392 "dlx_dlx.yac"
{ yyval.valu = DLX_SHLDFN; ;
    break;}
case 100:
#line 1394 "dlx_dlx.yac"
{ yyval.valu = DLX_SHRDFN; ;
    break;}
case 101:
#line 1399 "dlx_dlx.yac"
{ yyval.valu = DLX_MULDFN; ;
    break;}
case 102:
#line 1401 "dlx_dlx.yac"
{ yyval.valu = DLX_DIVDFN; ;
    break;}
case 103:
#line 1408 "dlx_dlx.yac"
{
		yyval.immd = yyvsp[-1].immd;
		;
    break;}
case 104:
#line 1415 "dlx_dlx.yac"
{
		yyval.immd.valu = - yyvsp[-1].immd.valu;
		yyval.immd.flag = yyvsp[-1].immd.flag;
		;
    break;}
case 105:
#line 1420 "dlx_dlx.yac"
{ yyval.immd = yyvsp[0].immd; ;
    break;}
case 106:
#line 1425 "dlx_dlx.yac"
{ yyval.valu = DLX_ORDFN; ;
    break;}
case 107:
#line 1427 "dlx_dlx.yac"
{ yyval.valu = DLX_ANDDFN; ;
    break;}
case 108:
#line 1429 "dlx_dlx.yac"
{ yyval.valu = DLX_XORDFN; ;
    break;}
case 109:
#line 1434 "dlx_dlx.yac"
{ yyval.valu = DLX_PLSDFN; ;
    break;}
case 110:
#line 1436 "dlx_dlx.yac"
{ yyval.valu = DLX_MNSDFN; ;
    break;}
case 111:
#line 1441 "dlx_dlx.yac"
{
		yyval.immd.valu = yyvsp[0].valu;
		yyval.immd.flag = 'i';
		;
    break;}
case 112:
#line 1447 "dlx_dlx.yac"
{
		yyval.immd.valu = - yyvsp[0].valu;
		yyval.immd.flag = 'i';
		;
    break;}
case 113:
#line 1452 "dlx_dlx.yac"
{
		unsigned long imd;

		imd     = beh_chktab (DLX_HSHTAB, yyvsp[0].text, NULL, 7);
		yyval.immd.valu = imd;
		yyval.immd.flag = beh_chktab (DLX_HSHTAB, yyvsp[0].text, NULL, 0);
		;
    break;}
case 114:
#line 1461 "dlx_dlx.yac"
{
		unsigned long imd;

		imd     = beh_chktab (DLX_HSHTAB, yyvsp[0].text, NULL, 7);
		yyval.immd.valu = -imd;
		yyval.immd.flag = beh_chktab (DLX_HSHTAB, yyvsp[0].text, NULL, 0);
		;
    break;}
case 115:
#line 1472 "dlx_dlx.yac"
{ yyval.valu = yyvsp[0].valu; ;
    break;}
case 116:
#line 1477 "dlx_dlx.yac"
{ yyval.valu = yyvsp[0].valu; ;
    break;}
case 117:
#line 1482 "dlx_dlx.yac"
{ yyval.valu = yyvsp[0].valu; ;
    break;}
case 118:
#line 1487 "dlx_dlx.yac"
{ yyval.valu = yyvsp[0].valu; ;
    break;}
case 119:
#line 1492 "dlx_dlx.yac"
{ yyval.text = yyvsp[0].text; ;
    break;}
case 122:
#line 1503 "dlx_dlx.yac"
{ yyerrok; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/freeware/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1505 "dlx_dlx.yac"


static void dlx_error (code,str)

int   code;
char *str;

  {
  DLX_ERRFLG = 1;
  if (code <100)
    fprintf (stderr,"Error %d near line %d : ",code, DLX_LINNUM);

  switch (code)
    {
    case 2:
      fprintf (stderr, "missing label\n");
      break;
    case 3:
      fprintf (stderr, "redefinition of label\n");
      break;
    case 4:
      fprintf (stderr, "undifined string\n");
      break;
    case 5:
      fprintf (stderr, "parse error\n");
      break;
    case 100:
      fprintf (stderr, "cannot open file `%s`\n",str);
      break;
    case 101:
      fprintf (stderr, "usage: dlx_asm [<options>] <assembly_file> <vhdl_file> <vhdl_file>\n");
      break;
    }
  }

yyerror (str)

char *str;

  {
  DLX_ERRFLG = 1;
  fprintf (stderr, "line %d : %s\n",DLX_LINNUM, str);
  }

static void dlx_head (fp, name, adr_siz, wrd_siz)

FILE         *fp;
char         *name;
unsigned int  adr_siz;
unsigned int  wrd_siz;

  {
  adr_siz --;
  wrd_siz = (wrd_siz * 8) - 1;

  fprintf (fp, "entity %s is\n  port (\n", name);
  fprintf (fp, "    address : in  bit_vector (%u downto 0);\n", adr_siz);
  fprintf (fp, "    e_n     : in  bit;\n");
  fprintf (fp, "    data    : out mux_vector (%u downto 0) bus;\n", wrd_siz);
  fprintf (fp, "    vdd     : in bit;\n");
  fprintf (fp, "    vss     : in bit);\nend %s;\n\n",name);
  fprintf (fp, "architecture VBE of %s is\n\n", name);
  fprintf (fp, "  signal rom_out : bit_vector (%u downto 0);\n\n", wrd_siz);
  fprintf (fp, "begin\n\n");
  fprintf (fp, "  write_out : block (e_n = '0')\n  begin\n");
  fprintf (fp, "    data <= guarded rom_out;\n  end block;\n\n");
  fprintf (fp, "  with address (%u downto 0) select\n  rom_out <=\n", adr_siz);
  }

static void dlx_foot (fp, wrd_siz)

FILE         *fp     ;
unsigned int  wrd_siz;

  {
  unsigned int i;

  fprintf (fp, "          X\"");

  for (i=0 ; i<wrd_siz ; i++)
    fprintf (fp, "00");

  fprintf (fp, "\" when others;\n\nend;\n");
  }

/* ###--------------------------------------------------------------### */
/* function	: dlx_print						*/
/* description	: print one or several lines of the rom content. the	*/
/*		  global variable 'word size' defines the size of the	*/
/*		  rom line in bytes.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void dlx_print (byte_nbr)

int byte_nbr;

  {
  unsigned int  i    ;
  unsigned int  j    ;
  unsigned long adr  ;
  unsigned long mask ;
  char          binadr [36];

  if (byte_nbr != 0)
    {
    if (DLX_WRDSIZ == 4)
      adr = DLX_ADDRES >> 2;
    else
      adr = DLX_ADDRES;

    for (i=0 ; i<byte_nbr ; i += DLX_WRDSIZ)
      {
      fprintf (DLX_WRTFIL, "          X\"");

      for (j=0 ; j<DLX_WRDSIZ ; j++)
        fprintf (DLX_WRTFIL, "%.2x", DLX_BYTTAB [i+j]);

      mask = 0x00000001 << (DLX_ADRSIZ - 1);
      for (j=0 ; j<DLX_ADRSIZ ; j++)
        {
        if ((adr & mask) != 0)
          binadr [j] = '1';
        else
          binadr [j] = '0';
        mask = mask >> 1;
        }
      binadr [j] = '\0';

      fprintf (DLX_WRTFIL, "\" when B\"%s\",\n", binadr);
      adr++;
      }
    }
  }

	/* ###------------------------------------------------------### */
	/* function	: dlx_symbol					*/
	/* description	: print out the location (in text or data	*/
	/*		  region) of a symbol				*/
	/* called func.	: none						*/
	/* ###------------------------------------------------------### */

static void dlx_symbol (str)

char *str;
  {
  char *seg;

  if (DLX_ADRSPC == 'T')
    seg = "text";
  else
    seg = "data";

  fprintf (DLX_SYMFIL, "%s\t: location %x in %s segment\n", str,
           DLX_ADDRES, seg);
  }

static int dlx_strtobin (str, tab)

char *str;
char *tab;

  {
  int  i  = 1;
  int  j  = 0;

  while (str [i] != '\0')
    {
    tab [j] = str [i];
    i++;
    if (str[i-1] == '\\')
      {
      if ((str [i] <= '7') && (str [i] >= '0'))
        {
        tab [j] = str [i] - '0';
        i++;
        if ((str [i] <= '7') && (str [i] >= '0'))
          {
          tab [j] = (tab [j] * 8) + (str [i] - '0');
          i++;
          if ((str [i] <= '7') && (str [i] >= '0'))
            tab [j] = (tab [j] * 8) + (str [i] - '0');
          }
        }
      else
        {
        if (str [i] == '"')
          {
          tab [j] = str [i];
          i++;
          }
        }
      }

    j++;
    }

  return (j-1);
  }
