/*
 * $Author: alliance $
 * $Id: fpm_net.h,v 1.1.1.1 1998/10/21 16:32:41 alliance Exp $
 * $Date: 1998/10/21 16:32:41 $
 */
/*
 * $Log: fpm_net.h,v $
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 */

#ifndef __fpmnet_h
#define __fpmnet_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
# ifdef __STDC__
#  define __P(args)	args
# else
#  define __P(args)	()
# endif
#endif

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

typedef struct fpnetwork {
	char		*NAME;
	bddsystem	*BDD_SYSTEM;

	bflmap_t	*MAP_INPUT;
	bflmap_t	*MAP_OUTPUT;
} fpnetwork_t;

typedef struct fpinput {
	bddindex	 INDEX;
	bddnode		*BDD;
	chain_list	*LIST_OUTPUT;
} fpinput_t;

typedef struct fpoutput {
	char		*NAME;
	bddnode		*BDD;
	int		 COST;
} fpoutput_t;

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

#endif /* __fpmnet_h */
