
/*  A Bison parser, made from bvl_bcomp.yac
    by GNU Bison version 1.28  */

#define BVL_Y_BISON 1  /* Identify Bison output.  */

#define	_AND	257
#define	_BEGIN	258
#define	_END	259
#define	_EQSym	260
#define	_EXIT	261
#define	_FILE	262
#define	_GESym	263
#define	_GTSym	264
#define	_IN	265
#define	_INOUT	266
#define	_LABEL	267
#define	_LESym	268
#define	_LINKAGE	269
#define	_LTSym	270
#define	_NAND	271
#define	_NESym	272
#define	_NEXT	273
#define	_NOR	274
#define	_NOT	275
#define	_NULL	276
#define	_OR	277
#define	_OUT	278
#define	_XOR	279
#define	ABS	280
#define	ACCESS	281
#define	AFTER	282
#define	ALIAS	283
#define	ALL	284
#define	ARCHITECTURE	285
#define	ARRAY	286
#define	ASSERT	287
#define	ATTRIBUTE	288
#define	AbstractLit	289
#define	Ampersand	290
#define	Apostrophe	291
#define	Arrow	292
#define	BIT	293
#define	BIT_VECTOR	294
#define	BLOCK	295
#define	BODY	296
#define	BUFFER	297
#define	BUS	298
#define	Bar	299
#define	BasedInt	300
#define	BasedReal	301
#define	BitStringLit	302
#define	Box	303
#define	CASE	304
#define	COMPONENT	305
#define	CONFIGURATION	306
#define	CONSTANT	307
#define	CharacterLit	308
#define	Colon	309
#define	Comma	310
#define	DISCONNECT	311
#define	DOWNTO	312
#define	DecimalInt	313
#define	DecimalReal	314
#define	Dot	315
#define	DoubleStar	316
#define	ELSE	317
#define	ELSIF	318
#define	ENTITY	319
#define	ERROR	320
#define	FOR	321
#define	FS	322
#define	FUNCTION	323
#define	GENERATE	324
#define	GENERIC	325
#define	GUARDED	326
#define	IF	327
#define	IS	328
#define	Identifier	329
#define	LIBRARY	330
#define	LOOP	331
#define	LeftParen	332
#define	MAP	333
#define	MOD	334
#define	MS	335
#define	MUX_BIT	336
#define	MUX_VECTOR	337
#define	Minus	338
#define	NATURAL	339
#define	NATURAL_VECTOR	340
#define	NEW	341
#define	NS	342
#define	OF	343
#define	ON	344
#define	OPEN	345
#define	OTHERS	346
#define	PACKAGE	347
#define	PORT	348
#define	PROCEDURE	349
#define	PROCESS	350
#define	PS	351
#define	Plus	352
#define	RANGE	353
#define	RECORD	354
#define	REG_BIT	355
#define	REG_VECTOR	356
#define	REGISTER	357
#define	REM	358
#define	REPORT	359
#define	RETURN	360
#define	RightParen	361
#define	SELECT	362
#define	SEVERITY	363
#define	SIGNAL	364
#define	_STABLE	365
#define	SUBTYPE	366
#define	Semicolon	367
#define	Slash	368
#define	Star	369
#define	StringLit	370
#define	THEN	371
#define	TO	372
#define	TRANSPORT	373
#define	_TYPE	374
#define	UNITS	375
#define	UNTIL	376
#define	US	377
#define	USE	378
#define	VARIABLE	379
#define	VarAsgn	380
#define	WAIT	381
#define	WARNING	382
#define	WHEN	383
#define	WHILE	384
#define	WITH	385
#define	WOR_BIT	386
#define	WOR_VECTOR	387

#line 10 "bvl_bcomp.yac"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include MUT_H
#include LOG_H
#include BEH_H
#include BVL_H
#include "bvl_byacc.h"
#include "bvl_bedef.h"

/* ###--------------------------------------------------------------### */
/* function	: bvl_y_error						*/
/* description	: print an error message				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void bvl_y_error (str)

char *str;
  {
  BVL_ERRFLG++;
  fprintf (stderr, "`%s` Error line %d : %s\n", BVL_CURFIL, BEH_LINNUM, str);
  }

/* ###--------------------------------------------------------------### */
/* function	: tobin							*/
/* description	: translate a StringLit, BitStringLit or CharacterLit	*/
/*		  in a string of '0' and '1's				*/
/* ###--------------------------------------------------------------### */

static int tobin (trg, src, left, right)

char *trg  ;
char *src  ;
int   left ;
int   right;

  {
  char base         ;
  int  indx         ;
  int  j            = 0;
  int  errflg       = 0;
  char lcl_trg [256];

  lcl_trg [0] = '\0';

  if (src == NULL)
    {
    strcpy (trg,"0");
    }
  else
    {
    if (!strcmp (src,"others"))
      {
      strcpy (trg, src);
      }
    else
      {
      if ((src [0] != '\'') && (src [0] != '"') && (src [0] != '%'))
        {
        base = src [0];
        indx = 2;
        }
      else
        {
        base = 'B';
        indx = 1;
        }

      switch (base)
        {
        case 'B' :
        case 'b' :
          while ((lcl_trg[j] = src[indx]) != '\0')
            {
            switch (src[indx])
              {
              case '0':
              case '1':
              case 'd':				/* Beware Not VHDL	*/
                j++; break;

              case '%' :
              case '"' :
              case '\'':
              case '_' :
                break;

	    default :
	      errflg = 1; bvl_error (73,src);
              }
            indx++;
            }
          break;

        case 'O' :
        case 'o' :
          while (src[indx] != '\0')
            {
            j += 3;
            switch (src[indx])
              {
              case '0' :
                strcat (lcl_trg,"000"); break;
              case '1' :
                strcat (lcl_trg,"001"); break;
              case '2' :
                strcat (lcl_trg,"010"); break;
              case '3' :
                strcat (lcl_trg,"011"); break;
              case '4' :
                strcat (lcl_trg,"100"); break;
              case '5' :
                strcat (lcl_trg,"101"); break;
              case '6' :
                strcat (lcl_trg,"110"); break;
              case '7' :
                strcat (lcl_trg,"111"); break;
              case '"' :
              case '%' :
              case '_' :
                j -= 3; break;
	      default :
	        j -= 3; errflg = 1; bvl_error (73, src);
              }
            indx++;
            }
          break;

        case 'X' :
        case 'x' :
          while (src[indx] != '\0')
            {
            j += 4;
            switch (src[indx])
              {
              case '0' :
                strcat (lcl_trg,"0000"); break;
              case '1' :
                strcat (lcl_trg,"0001"); break;
              case '2' :
                strcat (lcl_trg,"0010"); break;
              case '3' :
                strcat (lcl_trg,"0011"); break;
              case '4' :
                strcat (lcl_trg,"0100"); break;
              case '5' :
                strcat (lcl_trg,"0101"); break;
              case '6' :
                strcat (lcl_trg,"0110"); break;
              case '7' :
                strcat (lcl_trg,"0111"); break;
              case '8' :
                strcat (lcl_trg,"1000"); break;
              case '9' :
                strcat (lcl_trg,"1001"); break;
              case 'a' :
              case 'A' :
                strcat (lcl_trg,"1010"); break;
              case 'b' :
              case 'B' :
                strcat (lcl_trg,"1011"); break;
              case 'c' :
              case 'C' :
                strcat (lcl_trg,"1100"); break;
              case 'd' :
              case 'D' :
                strcat (lcl_trg,"1101"); break;
              case 'e' :
              case 'E' :
                strcat (lcl_trg,"1110"); break;
              case 'f' :
              case 'F' :
                strcat (lcl_trg,"1111"); break;
              case '%' :
              case '"' :
              case '_' :
                j -= 4; break;
	      default :
	        j -= 4; errflg = 1; bvl_error(73,src);
              }
            indx++;
            }
          break;

        default :
          beh_toolbug (17, "tobin", NULL, base);
        }

      if ((j == 0) || (j <= right))
        {
        trg[0] = '0';
        trg[1] = '\0';
        }
      else
        {
        if (left != -1)
          {
          strcpy (trg, &lcl_trg[left]);
          trg[right - left + 1] = '\0';
          }
        else
          strcpy (trg, lcl_trg);
        }
      }
    }

  return (errflg);
  }

/* ###--------------------------------------------------------------### */
/* function	: chkdcl						*/
/* ###--------------------------------------------------------------### */

static int chkdcl (object, mode, type, flag, kind, constraint, conf)

char object    ;
int  mode      ;
int  type      ;
char flag      ;
int  kind      ;
char constraint;
int  *conf     ;

  {
  int errflg = 0;
  int lclcnf = 0;

  if (flag != constraint)
    {
    errflg = 1;
    bvl_error (33, NULL);
    }
  else
    {
    switch (object)
      {
      case 'P':
	/* ###------------------------------------------------------### */
	/*    If object is a port :					*/
	/*       - if type is bit, no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:

            lclcnf += BVL_BITDFN + BVL_NORDFN;
            switch (mode)
              {
              case _IN :
                lclcnf += BVL_ICNDFN; break;
              case _OUT:
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != 0)
              errflg = 1;
            break;

          case MUX_BIT:

            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case WOR_BIT:

            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            switch (mode)
              {
              case _OUT :
                lclcnf += BVL_OCNDFN; break;
              case _INOUT :
                lclcnf += BVL_BCNDFN; break;
              case _IN :
              case _LINKAGE :
              case 0 :
                errflg = 1; break;
              }
            if (kind != BUS)
              errflg = 1;
            break;

          case REG_BIT:
          case NATURAL:

            errflg = 1;
            break;
          }
        if (errflg == 1)
          bvl_error (5, NULL);
        break;

      case 'G':
	/* ###------------------------------------------------------### */
	/*    If object is a generic :					*/
	/*       - only natural type is allowed				*/
	/* ###------------------------------------------------------### */

        if ((type != NATURAL) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (77, NULL);
          }
        break;

      case 'S':
	/* ###------------------------------------------------------### */
	/*    If object is a signal :					*/
	/*       - no mode can be specified				*/
	/*       - if type is bit no guard indication can be used	*/
	/*       - if type is wor_bit or mux_bit, bus kind must be used	*/
	/*       - if type is reg_bit, register kind must be used	*/
	/*       - other types are illegal				*/
	/* ###------------------------------------------------------### */

        switch (type)
          {
          case BIT:
            lclcnf += BVL_BITDFN + BVL_NORDFN;
            if ((mode != 0) || (kind != 0))
              errflg = 1;
            break;
          case MUX_BIT:
            lclcnf += BVL_MUXDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case WOR_BIT:
            lclcnf += BVL_WORDFN + BVL_BUSDFN;
            if ((mode != 0) || (kind != BUS))
              errflg = 1;
            break;
          case REG_BIT:
            lclcnf += BVL_RBIDFN + BVL_REGDFN;
            if ((mode != 0) || (kind != REGISTER))
              errflg = 1;
            break;
          case NATURAL:
            errflg = 1; break;
          }

        if (mode != 0)
          errflg = 1;

        if (errflg == 1)
          bvl_error (11, NULL);
        break;

      case 'C':
	/* ###------------------------------------------------------### */
	/*    If object is a constant :					*/
	/*       - only bit type without any other indication is legal	*/
	/* ###------------------------------------------------------### */

        lclcnf += BVL_CSTDFN;
        if ((type != BIT) || (mode != 0) || (kind != 0))
          {
          errflg = 1;
          bvl_error (78, NULL);
          }
        break;
      }
    }

  *conf = lclcnf ;
  return (errflg);
  }

/* ###--------------------------------------------------------------### */
/* function	: addstr						*/
/* ###--------------------------------------------------------------### */

static void *addstr (ptfig, object, mode, type, flag, name, left, right)

struct befig *ptfig ;
char          object;
int           mode  ;
int           type  ;
char          flag  ;
char         *name  ;
short         left  ;
short         right ;

  {
  void  *pnt          = NULL;
  char   porflg       = 0;
  char   rinflg       = 0;
  char   outflg       = 0;
  char   busflg       = 0;
  char   auxflg       = 0;
  char   buxflg       = 0;
  char   regflg       = 0;
  char   lclmod       = 'I';
  char   lcltyp       = 'B';
  char   extname [100];
  short  i            ;
  short  inc          = 1;

  switch (object)
    {
    case 'P':

	/* ###------------------------------------------------------### */
	/*   if object is a port ...					*/
	/* ###------------------------------------------------------### */

      porflg = 1;
      switch (mode)
        {
        case _IN:
          lclmod = 'I'; lcltyp = 'B'; rinflg = 1; break;
        case _OUT:
          switch (type)
            {
            case BIT:
              lclmod = 'O'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'Z'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'Z'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        case _INOUT:
          rinflg = 1;
          switch (type)
            {
            case BIT:
              lclmod = 'B'; lcltyp = 'B'; outflg = 1; break;
            case MUX_BIT:
              lclmod = 'T'; lcltyp = 'M'; busflg = 1; break;
            case WOR_BIT:
              lclmod = 'T'; lcltyp = 'W'; busflg = 1; break;
            }
          break;
        }
      break;

    case 'S':

	/* ###------------------------------------------------------### */
	/*   if object is a signal ...					*/
	/* ###------------------------------------------------------### */

      switch (type)
        {
        case BIT:
          lcltyp = 'B'; rinflg = BVL_AUXMOD; auxflg = 1; break;
        case REG_BIT:
          rinflg = 1; regflg = 1; break;
        case MUX_BIT:
          lcltyp = 'M'; rinflg = 1; buxflg = 1; break;
        case WOR_BIT:
          lcltyp = 'W'; rinflg = 1; buxflg = 1; break;
        }
      break;
    }

  if (flag == 'S')
    {
	/* ###------------------------------------------------------### */
	/*   if object is a scalar ...					*/
	/* ###------------------------------------------------------### */

    if (porflg == 1)
      ptfig->BEPOR = beh_addbepor (ptfig->BEPOR, name, lclmod, lcltyp);
    if (rinflg == 1)
      ptfig->BERIN = beh_addberin (ptfig->BERIN, name);
    if (outflg == 1)
      ptfig->BEOUT = beh_addbeout (ptfig->BEOUT, name, NULL, NULL);
    if (busflg == 1)
      ptfig->BEBUS = beh_addbebus (ptfig->BEBUS, name, NULL, NULL, lcltyp);
    if (auxflg == 1)
      ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX, name, NULL, NULL);
    if (buxflg == 1)
      ptfig->BEBUX = beh_addbebux (ptfig->BEBUX, name, NULL, NULL, lcltyp);
    if (regflg == 1)
      ptfig->BEREG = beh_addbereg (ptfig->BEREG, name, NULL, NULL);

    }
  else
    {
	/* ###------------------------------------------------------### */
	/*   if object is an array ...					*/
	/* ###------------------------------------------------------### */

    if (left >= right)
      inc = -1;

    for (i=left ; i!=(right+inc) ; i+=inc)
      {
      sprintf (extname, "%s %d", name, i);

      if (porflg == 1)
        ptfig->BEPOR = beh_addbepor (ptfig->BEPOR, extname, lclmod, lcltyp);
      if (rinflg == 1)
        ptfig->BERIN = beh_addberin (ptfig->BERIN, extname);
      if (outflg == 1)
        ptfig->BEOUT = beh_addbeout (ptfig->BEOUT, extname, NULL, NULL);
      if (busflg == 1)
        ptfig->BEBUS = beh_addbebus (ptfig->BEBUS, extname, NULL, NULL, lcltyp);
      if (auxflg == 1)
        ptfig->BEAUX = beh_addbeaux (ptfig->BEAUX, extname, NULL, NULL);
      if (buxflg == 1)
        ptfig->BEBUX = beh_addbebux (ptfig->BEBUX, extname, NULL, NULL, lcltyp);
      if (regflg == 1)
        ptfig->BEREG = beh_addbereg (ptfig->BEREG, extname, NULL, NULL);
      }
    }

  if (outflg == 1)
    pnt = (void *) ptfig->BEOUT;
  if (busflg == 1)
    pnt = (void *) ptfig->BEBUS;
  if (auxflg == 1)
    pnt = (void *) ptfig->BEAUX;
  if (buxflg == 1)
    pnt = (void *) ptfig->BEBUX;
  if (regflg == 1)
    pnt = (void *) ptfig->BEREG;

  return (pnt);
  }

/* ###--------------------------------------------------------------### */
/* function	: addgen						*/
/* description	: create one or more BEGEN structures			*/
/*		  For a scalar a BEGEN is created at the head of	*/
/*		  existing BEGEN list.					*/
/*		  For an array (including arraies of one element) a set	*/
/*		  of BEGENs are created in a sorted list. BEGEN related	*/
/*		  to the index i of the array is named `name(i)`. The	*/
/*		  head of the list represents the right bound of the	*/
/*		  array. This list is then chained to the head of	*/
/*		  existing BEGEN list.					*/
/* called func.	: beh_addbegen, namealloc				*/
/* ###--------------------------------------------------------------### */

static struct begen *addgen (last_gen, nat_lst, nam_lst, type, left, right)

struct begen *last_gen; 	/* pointer on the last begen structure	*/
struct chain *nam_lst ;		/* generic's name list			*/
struct chain *nat_lst ;		/* generic's value list			*/
char         *type    ;		/* generic's type			*/
short         left    ;		/* array's left bound (= -1 if scalar)	*/
short         right   ;		/* array's right bound (= -1 if scalar)	*/

  {
  char          extname [128];
  char         *name         ;
  struct begen *ptgen        ;
  struct chain *ptauxnam     ;
  struct chain *ptauxnat     ;
  int           i            ;
  int           inc          = 1;

  ptgen    = last_gen;
  ptauxnam = nam_lst ;
  ptauxnat = nat_lst ;

  if ((left == -1) && (right == -1))
    {
    if ((ptauxnat != NULL) && (ptauxnat->NEXT == NULL))
      {
      while (ptauxnam != NULL)
        {
        name     = namealloc    ((char *) ptauxnam->DATA);
        ptgen    = beh_addbegen (ptgen, name, type, (void *) ptauxnat->DATA);
        ptauxnam = ptauxnam->NEXT;
        }
      }
    else
      bvl_error (75, NULL);
    }
  else
    {
    if (left >= right)
      inc = -1;

    while (ptauxnam != NULL)
      {
      for (i=left ; i!=(right+inc) ; i+=inc)
        {
        sprintf (extname, "%s %d", (char *)ptauxnam->DATA, i);
        name = namealloc (extname);

        if (ptauxnat != NULL)
          {
          ptgen    = beh_addbegen (ptgen, name, type, (void *)ptauxnat->DATA);
	  ptauxnat = ptauxnat->NEXT;
          }
        else
          bvl_error (75, NULL);
        }

      if (ptauxnat != NULL)
        bvl_error (75, NULL);

      ptauxnat = nat_lst;
      ptauxnam = ptauxnam->NEXT;
      }
    }
  return (ptgen);
  }

/* ###--------------------------------------------------------------### */
/* function	: cpyabllst						*/
/* description	: duplicate bvl_abllst structure 			*/
/* called func.	: addchain, reverse, copyExpr				*/
/* ###--------------------------------------------------------------### */

static struct chain *cpyabllst (abllst)

struct chain *abllst;
  {
  struct chain *pt_abllst = NULL;

  while (abllst != NULL)
    {
    pt_abllst = addchain (pt_abllst, copyExpr ((struct chain *)abllst->DATA));
    abllst    = abllst->NEXT;
    }

  pt_abllst = reverse (pt_abllst);
  return (pt_abllst);
  }

/* ###--------------------------------------------------------------### */
/* function	: cpyablstr						*/
/* description	: duplicate bvl_ablstr structure 			*/
/* called func.	: mbkalloc, cpyabllst					*/
/* ###--------------------------------------------------------------### */

static bvl_ablstr cpyablstr (ablstr)

bvl_ablstr ablstr;
  {
  bvl_ablstr pt_ablstr;

  pt_ablstr.IDENT    = NULL;
  pt_ablstr.WIDTH    = ablstr.WIDTH;
  pt_ablstr.LIST_ABL = cpyabllst (ablstr.LIST_ABL);

  return (pt_ablstr);
  }

/* ###--------------------------------------------------------------### */
/* function     : crtabl						*/
/* description  : combine at most two ABLs and build a new one          */
/*    		  The following operations can be performed :		*/
/*		    CONC    perform concatenation			*/
/*		    NOPI    initialize a structure for a signal (scalar	*/
/*		            or array)					*/
/*		    NOPS    initialize a structure for a literal	*/
/*		    NE      create a structure with an ABL representing	*/
/*		            the 'non equality' of two expressions	*/
/*		    EQ      create a structure with an ABL representing	*/
/*		            the 'equality' of two expressions		*/
/*		    NOT     perform logical not of an expression	*/
/*		    AND     perform logical and  between two expressions*/
/*		    OR      perform logical or   between two expressions*/
/*		    NAND    perform logical nand between two expressions*/
/*		    NOR     perform logical nor  between two expressions*/
/*		    XOR     perform logical xor  between two expressions*/
/*		    ANDM    perform logical and  between two expressions*/
/*		            (the second expression is a scalar)		*/
/* called func. : createAtom , createExpr, addQExpr , beh_toolbug,	*/
/*		  bvl_error , addchain   , freechain			*/
/* ###--------------------------------------------------------------### */

static bvl_ablstr crtabl (oper, expr1, expr2, left, right)

short      oper ;
bvl_ablstr expr1;
bvl_ablstr expr2;
int        left ;
int        right;

  {
  char            name [256]      ;
  char           *name2           ;
  struct chain   *pt_abl1         = NULL;
  struct chain   *pt_abl2         = NULL;
  struct chain   *pt_aux1         = NULL;
  struct chain   *pt_aux2         = NULL;
  bvl_ablstr      result          ;
  char            lcl_buffer [256];
  short           inc             ;
  short           i               ;
  char            true_flag_un    = 0;
  char            true_flag_zero  = 0;
  struct chain   *abl_un          = createAtom ("'1'");
  struct chain   *abl_zero        = createAtom ("'0'");

  result.IDENT    = NULL;
  result.TIME     = 0   ;
  result.LIST_ABL = NULL;
  result.WIDTH    = 0   ;

  switch (oper)
    {
    case CONC :
      if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
        beh_toolbug (4, "crtabl", NULL, 0);
      else
        {
        if (expr1.LIST_ABL == expr2.LIST_ABL)
          beh_toolbug (16, "crtabl", NULL, 0);
        else
          {
          pt_aux2 = expr2.LIST_ABL;
          while (pt_aux2->NEXT != NULL)
            pt_aux2 = pt_aux2->NEXT;

          pt_aux2->NEXT = expr1.LIST_ABL;

          result.LIST_ABL = expr2.LIST_ABL;
          result.WIDTH    = expr1.WIDTH + expr2.WIDTH;

          expr1.LIST_ABL  = NULL;
          expr2.LIST_ABL  = NULL;
          }
        }
      break;

      case NOPI :
        if (expr1.IDENT == NULL)
          beh_toolbug (2, "crtabl", NULL, 0);
        else
          {
          if ((left == -1) && (right == -1))
            {
            result.LIST_ABL = addchain(result.LIST_ABL,createAtom(expr1.IDENT));
            result.WIDTH    = 1;
            }
          else
            {
            if (left <= right)
              {
              inc = 1;
              result.WIDTH = right - left + 1;
              }
            else
              {
              inc = -1;
              result.WIDTH = left - right + 1;
              }

            for (i=left ; i!=(right+inc) ; i+=inc)
              {
              sprintf (name,"%s %i",expr1.IDENT,i);
              name2           = namealloc (name);
              result.LIST_ABL = addchain (result.LIST_ABL,createAtom(name2));
              }
            }
          expr1.IDENT = NULL;
          }
        break;

      case NOPS :
        if (expr1.IDENT == NULL)
          beh_toolbug (2, "crtabl", NULL, 0);
        else
          {
          tobin (lcl_buffer, expr1.IDENT, -1, -1);
          if ((left == -1) && (right == -1))
            {
            left  = 0;
            right = strlen (lcl_buffer) - 1;
            }

          for (i=left ; i<=right ; i++)
            {
            switch ( lcl_buffer[i] )
              {
              case '0' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'0'"));
                break;
              case '1' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'1'"));
                break;
/*-----------        Beware Not VHDL        -------------*/
              case 'd' :
                result.LIST_ABL = addchain (result.LIST_ABL,createAtom("'D'"));
                break;
              default  :
                beh_toolbug (15, "crtabl", NULL, expr1.IDENT[i]);
              }
            }
          result.WIDTH = right - left + 1;
          }
        break;

      case STABLE :
        if (expr1.LIST_ABL == NULL)
	  beh_toolbug (3, "crtabl", NULL, 0);
        else
          {
	  pt_aux1 = expr1.LIST_ABL;
          while (pt_aux1 != NULL)
            {
            pt_abl1  = createExpr (STABLE);
            addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
            pt_aux1->DATA = pt_abl1;
            pt_aux1  = pt_aux1->NEXT;
            }

          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;

          expr1.LIST_ABL  = NULL;
          }
        break;

      case NOT :
        if (expr1.LIST_ABL == NULL)
	  beh_toolbug (3, "crtabl", NULL, 0);
        else
          {
	  pt_aux1  = expr1.LIST_ABL;
          while (pt_aux1 != NULL)
            {
            pt_abl1  = createExpr (NOT);
            addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
            pt_aux1->DATA = pt_abl1;
            pt_aux1  = pt_aux1->NEXT;
            }

          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;

          expr1.LIST_ABL  = NULL;
          }
        break;

      case EQ :
        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	  beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr1.WIDTH != expr2.WIDTH)
            {
            bvl_error (38,NULL);
            pt_abl2 = createAtom ("'1'");

	    pt_aux1 = expr1.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              freeExpr (pt_aux1->DATA);
              pt_aux1 = pt_aux1->NEXT;
              }
	    pt_aux2 = expr2.LIST_ABL;
            while (pt_aux2 != NULL)
              {
              freeExpr (pt_aux2->DATA);
              pt_aux2 = pt_aux2->NEXT;
              }
            }
          else
            {
	    pt_aux1 = expr1.LIST_ABL;
	    pt_aux2 = expr2.LIST_ABL;
            /* If expr2 = '1' then return expr1 */
            while(pt_aux2 != NULL)
              {
              true_flag_un = 1;
              if(!equalExpr(pt_aux2->DATA,abl_un))
                {
                /* One abl not abl_un */
                true_flag_un = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_un == 1)
              {
              pt_abl1 = (struct chain *)pt_aux1->DATA;
              pt_aux1 = pt_aux1->NEXT;
              if(pt_aux1 != NULL)
                {
                pt_abl2 = createExpr(AND);
                addQExpr(pt_abl2,pt_abl1);
                pt_abl1 = pt_abl2;
                }
              while(pt_aux1 != NULL)
                {
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1 = pt_aux1->NEXT;
                }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            /* If expr2 = '0' then return NOT(expr1) */
	    pt_aux2 = expr2.LIST_ABL;
            true_flag_zero = 0;
            while(pt_aux2 != NULL)
              {
              true_flag_zero = 1;
              if(!equalExpr(pt_aux2->DATA,abl_zero))
                {
                /* One abl not abl_zero */
                true_flag_zero = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_zero == 1)
              {
              while(pt_aux1 != NULL)
                {
                pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1 = pt_aux1->NEXT;
                if(pt_aux1 != NULL)
                  {
                  pt_abl2 = createExpr(AND);
                  addQExpr(pt_abl2,pt_abl1);
                  pt_abl1 = pt_abl2;
                  }
                while(pt_aux1 != NULL)
                  {
                  pt_abl2 = createExpr(NOT);
                  addQExpr(pt_abl2,(struct chain *)pt_aux1->DATA);
                  addQExpr(pt_abl1,pt_abl2);
                  pt_aux1 = pt_aux1->NEXT;
                  }
                /* --pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1->DATA = pt_abl1;
                pt_aux1       = pt_aux1->NEXT;
                --- */
                }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
               
              
	    pt_aux2 = expr2.LIST_ABL;
            if((true_flag_zero == 0) && (true_flag_un == 0))
              {
              pt_abl1 = createExpr (XOR);
              addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

              pt_aux1 = pt_aux1->NEXT;
              pt_aux2 = pt_aux2->NEXT;

	      while (pt_aux1 != NULL)
	        {
                pt_abl2 = createExpr (OR);
                addQExpr (pt_abl2,pt_abl1);

                pt_abl1 = createExpr (XOR);
                addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                addQExpr (pt_abl2, pt_abl1);
                pt_abl1 = pt_abl2;

	        pt_aux1 = pt_aux1->NEXT;
	        pt_aux2 = pt_aux2->NEXT;
	        }
              pt_abl2 = createExpr (NOT);
              addQExpr (pt_abl2, pt_abl1);

              result.LIST_ABL = addchain (result.LIST_ABL,pt_abl2);
              result.WIDTH    = 1;
              freechain (expr1.LIST_ABL);
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL = NULL;
              expr2.LIST_ABL = NULL;
              }
            }
          }
        break;

      case NE :

        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	  beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr1.WIDTH != expr2.WIDTH)
            {
            bvl_error(38,NULL);
            pt_abl1 = createAtom ("'1'");

	    pt_aux1 = expr1.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              freeExpr (pt_aux1->DATA);
              pt_aux1 = pt_aux1->NEXT;
              }
	    pt_aux2 = expr2.LIST_ABL;
            while (pt_aux2 != NULL)
              {
              freeExpr (pt_aux2->DATA);
              pt_aux2 = pt_aux2->NEXT;
              }
            }
          else
            {
	    pt_aux1 = expr1.LIST_ABL;
	    pt_aux2 = expr2.LIST_ABL;

            /* If expr2 = '0' then return expr1 */
            while(pt_aux2 != NULL)
              {
              true_flag_zero = 1;
              if(!equalExpr(pt_aux2->DATA,abl_zero))
                {
                /* One abl not abl_zero */
                true_flag_zero = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_zero == 1)
              {
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            /* If expr2 = '1' then return NOT(expr1) */
	    pt_aux2 = expr2.LIST_ABL;
            true_flag_un = 0;
            while(pt_aux2 != NULL)
              {
              true_flag_un = 1;
              if(!equalExpr(pt_aux2->DATA,abl_un))
                {
                /* One abl not abl_un */
                true_flag_un = 0;
                break;
                }
              pt_aux2 = pt_aux2->NEXT;  
              }
            if(true_flag_un == 1)
              {
              while(pt_aux1 != NULL)
                {
                pt_abl1 = createExpr(NOT);
                addQExpr(pt_abl1,(struct chain *)pt_aux1->DATA);
                pt_aux1->DATA = pt_abl1;
                pt_aux1       = pt_aux1->NEXT;
                }
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = 1;
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
               
              
	    pt_aux2 = expr2.LIST_ABL;
            if((true_flag_zero == 0) && (true_flag_un == 0))
              {
              pt_abl1 = createExpr (XOR);
              addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);
  
              pt_aux1 = pt_aux1->NEXT;
              pt_aux2 = pt_aux2->NEXT;

  	      for (i=2 ; i<=expr1.WIDTH ; i++)
	        {
                pt_abl2 = createExpr (OR);
                addQExpr (pt_abl2, pt_abl1);

                pt_abl1 = createExpr (XOR);
                addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                addQExpr (pt_abl2, pt_abl1);
                pt_abl1 = pt_abl2;

	        pt_aux1 = pt_aux1->NEXT;
	        pt_aux2 = pt_aux2->NEXT;
	        }
              result.LIST_ABL = addchain(result.LIST_ABL,pt_abl1);
              result.WIDTH    = 1;
              freechain (expr1.LIST_ABL);
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL = NULL;
              expr2.LIST_ABL = NULL;
              }
            }
          }
        break;

      case AND  :
      case NAND :
      case OR   :
      case NOR  :
      case XOR  :

        if (expr1.LIST_ABL == NULL)
          {
          if (expr2.LIST_ABL == NULL)
	    beh_toolbug (4, "crtabl", NULL, 0);
          else
            {
            result.LIST_ABL = expr2.LIST_ABL;
            result.WIDTH    = expr2.WIDTH;
            expr2.LIST_ABL  = NULL;
            }
          }
        else
          {
          if (expr2.LIST_ABL == NULL)
            {
            result.LIST_ABL = expr1.LIST_ABL;
            result.WIDTH    = expr1.WIDTH;
            expr1.LIST_ABL  = NULL;
            }
          else
            {
            if (expr1.LIST_ABL == expr2.LIST_ABL)
              beh_toolbug (16, "crtabl", NULL, 0);
            else
              {
              if (expr1.WIDTH != expr2.WIDTH)
                {
                bvl_error(38,NULL);
                }
              else
                {
	        pt_aux1 = expr1.LIST_ABL;
	        pt_aux2 = expr2.LIST_ABL;

	        for (i=1 ; i<=expr1.WIDTH ; i++)
	          {
                  pt_abl1 = createExpr (oper);
                  addQExpr (pt_abl1, (struct chain *)pt_aux1->DATA);
                  addQExpr (pt_abl1, (struct chain *)pt_aux2->DATA);

                  pt_aux1->DATA = (void *)pt_abl1;

	          pt_aux1       = pt_aux1->NEXT;
	          pt_aux2       = pt_aux2->NEXT;
		  }
                }
              result.LIST_ABL = expr1.LIST_ABL;
              result.WIDTH    = expr1.WIDTH;
              freechain (expr2.LIST_ABL);
              expr1.LIST_ABL  = NULL;
              expr2.LIST_ABL  = NULL;
              }
            }
          }
        break;

      case ANDM :
        if ((expr1.LIST_ABL == NULL) || (expr2.LIST_ABL == NULL))
	    beh_toolbug (4, "crtabl", NULL, 0);
        else
          {
          if (expr2.WIDTH != 1)
            {
            bvl_error( 38,NULL);
            }
          else
            {
            pt_aux1 = expr1.LIST_ABL;
            pt_aux2 = expr2.LIST_ABL;
            while (pt_aux1 != NULL)
              {
              pt_abl1 = createExpr (AND);
              addQExpr (pt_abl1,          (struct chain *)pt_aux1->DATA);
              addQExpr (pt_abl1, copyExpr((struct chain *)pt_aux2->DATA));
              pt_aux1->DATA = (void *)pt_abl1;

              pt_aux1       = pt_aux1->NEXT;
              }
            }
          result.LIST_ABL = expr1.LIST_ABL;
          result.WIDTH    = expr1.WIDTH;
	  pt_aux2 = expr2.LIST_ABL;
          while (pt_aux2 != NULL)
            {
            freeExpr (pt_aux2->DATA);
            pt_aux2 = pt_aux2->NEXT;
            }
          freechain (expr2.LIST_ABL);
          expr2.LIST_ABL  = NULL;
          expr1.LIST_ABL  = NULL;
          }
        break;

      default :
	beh_toolbug (1, "crtabl", NULL, 0);
      }

    return (result);
    }

/* ###--------------------------------------------------------------### */
/* function	: bvl_select						*/
/* description	: create an abl representing the choice in a selected	*/
/*		  signal assignment and perform unicity verification	*/
/*		  using BDDs.						*/
/* called func.	: tobin       , bddToAbl     , addInputCct      ,	*/
/*		  substPhyExpr, initializeCct, createNodeTermBdd,	*/
/*		  bvl_error   , notBdd       , applyBinBdd      ,	*/
/*		  addchain    , namealloc				*/
/* ###--------------------------------------------------------------### */

static void bvl_select (result, pt_str, pt_bdd, pt_ablstr)

bvl_ablstr   *result;
struct chain *pt_str;		/* pointer on a list of choices		*/
pNode        *pt_bdd;		/* used to check if a choice is legal	*/
bvl_ablstr    pt_ablstr;	/* tested expression			*/

  {
  char             binstr[256];
  int              i;
  struct chain    *pt_auxabl;
  pNode            pt_bddres;
  pNode            pt_bddnew;
  pNode            pt_bddtmp;
  pNode            pt_bddaux;
  char             nomvar[10];
  struct chain    *pt_newabl;
  struct chain    *pt_newabl2;
  static int       oth_flg=0;
  static int       last_width=0;
  static pCircuit  pC = NULL;

  result->LIST_ABL = NULL;
  result->IDENT    = NULL;

  pt_bddtmp = zero;

  if (pC == NULL)
    pC = initializeCct ("-select-",200,0);

  if (*pt_bdd == NULL)
    {
    if (last_width < pt_ablstr.WIDTH)
      {
      for (; last_width<pt_ablstr.WIDTH ; last_width++)
        {
        sprintf (nomvar,"(%d)",last_width);
        createNodeTermBdd (addInputCct(pC,nomvar));
        }
      }
    *pt_bdd = zero;
    oth_flg = 0;
    }

  while (pt_str != NULL)
    {
    tobin (binstr, (char *)pt_str->DATA, -1, -1);
    if (oth_flg != 0)
      {
      bvl_error(30,NULL);
      }

    if (strcmp("others", (char *)pt_str->DATA))
      {
      pt_bddres = one;

      if (strlen (binstr) != pt_ablstr.WIDTH)
        {
        bvl_error(38,NULL);
        }
      for (i=0 ; binstr[i]!='\0' ; i++)
        {
        pt_bddaux = createNodeTermBdd (i+2);
        if (binstr[i] == '0')
          pt_bddaux = notBdd (pt_bddaux);
        pt_bddres = applyBinBdd (AND, pt_bddaux, pt_bddres);
        }
      pt_bddnew = applyBinBdd (OR,*pt_bdd,pt_bddres);

      if (*pt_bdd == pt_bddnew)
         {
         bvl_error(28,NULL);
         }

      *pt_bdd = pt_bddnew;
      }
    else
      {
      oth_flg   = 1;
      pt_bddres = notBdd (*pt_bdd);
      *pt_bdd   = one;
      }
    pt_bddtmp = applyBinBdd (OR,pt_bddtmp,pt_bddres);
    pt_str = pt_str->NEXT;
    }

  pt_newabl = bddToAbl (pt_bddtmp, pC->pNameI);

  pt_auxabl = pt_ablstr.LIST_ABL;
  i         = pt_ablstr.WIDTH - 1;
  while (pt_auxabl != NULL)
    {
    sprintf (nomvar,"(%i)",i);
/*--------
    substPhyExpr (pt_newabl,namealloc(nomvar),(struct chain *)pt_auxabl->DATA);
---------*/
    pt_newabl2 = substExpr (pt_newabl,namealloc(nomvar),
                            (struct chain *)pt_auxabl->DATA);
    freeExpr (pt_newabl);
    pt_newabl = pt_newabl2;

    i--;
    pt_auxabl = pt_auxabl->NEXT;
    }
  result->LIST_ABL = addchain (NULL, pt_newabl);
  result->WIDTH    = 1;

  }


#line 1352 "bvl_bcomp.yac"
typedef union  {
	long		 valu;
        float            flov;
	char		*text;
        bvl_ablstr       list;
	bvl_name	 name;
        struct g_type    dble;
	} BVL_Y_STYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	BVL_Y_FINAL		289
#define	BVL_Y_FLAG		-32768
#define	BVL_Y_NTBASE	134

#define BVL_Y_TRANSLATE(x) ((unsigned)(x) <= 387 ? bvl_y_translate[x] : 235)

static const short bvl_y_translate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   132,   133
};

#if BVL_Y_DEBUG != 0
static const short bvl_y_prhs[] = {     0,
     0,     1,     5,     6,    16,    19,    20,    22,    28,    32,
    35,    36,    40,    47,    49,    52,    54,    56,    57,    63,
    64,    68,    70,    71,    73,    77,    81,    83,    85,    86,
    88,    94,    98,   101,   102,   106,   114,   116,   117,   119,
   120,   122,   124,   126,   127,   140,   143,   145,   146,   149,
   151,   153,   156,   164,   167,   175,   176,   178,   180,   182,
   183,   186,   188,   190,   192,   195,   196,   207,   209,   212,
   214,   217,   219,   222,   224,   226,   232,   240,   241,   247,
   248,   260,   261,   265,   269,   271,   274,   275,   278,   281,
   283,   285,   287,   289,   291,   292,   296,   297,   301,   303,
   305,   307,   308,   311,   312,   315,   317,   319,   321,   323,
   325,   327,   329,   333,   337,   341,   345,   347,   351,   355,
   359,   363,   365,   369,   371,   373,   377,   379,   381,   384,
   386,   388,   390,   392,   394,   396,   398,   400,   404,   406,
   408,   410,   412,   417,   424,   428,   430,   432,   434,   436,
   438,   440,   442,   444,   446,   448,   450,   451,   455,   456,
   460,   461,   463,   464,   466,   470,   471,   473,   474,   476,
   477,   479,   481,   483,   486,   488,   490,   492,   494
};

static const short bvl_y_rhs[] = {    -1,
   135,   136,   160,     0,     0,    65,   227,    74,   137,   138,
   153,   234,   226,   233,     0,    65,     1,     0,     0,   139,
     0,    71,    78,   140,   232,   233,     0,    71,     1,   233,
     0,   142,   141,     0,     0,   141,   233,   142,     0,    53,
   218,    55,   217,   149,   143,     0,     1,     0,   126,   144,
     0,   231,     0,   145,     0,     0,    78,   148,   146,   147,
   232,     0,     0,   147,    56,   148,     0,   231,     0,     0,
   150,     0,    78,   151,   232,     0,   231,   152,   231,     0,
   118,     0,    58,     0,     0,   154,     0,    94,    78,   155,
   232,   233,     0,    94,     1,   233,     0,   157,   156,     0,
     0,   156,   233,   157,     0,   158,   218,    55,   159,   217,
   149,   168,     0,     1,     0,     0,   110,     0,     0,    11,
     0,    24,     0,    12,     0,     0,    31,    75,    89,   227,
    74,   161,   162,     4,   169,   234,   226,   233,     0,    31,
     1,     0,   163,     0,     0,   163,   164,     0,   167,     0,
   165,     0,     1,   233,     0,    53,    75,    55,   217,   149,
   166,   233,     0,   126,   210,     0,   110,   218,    55,   217,
   149,   168,   233,     0,     0,   103,     0,    44,     0,   170,
     0,     0,   170,   171,     0,   172,     0,   175,     0,   176,
     0,     1,   233,     0,     0,   229,    41,   222,     4,   173,
   174,   234,    41,   221,   233,     0,   170,     0,   229,   177,
     0,   177,     0,   229,   179,     0,   179,     0,   229,   181,
     0,   181,     0,   178,     0,    33,   198,   194,   195,   233,
     0,   228,    14,   225,   224,   180,   185,   233,     0,     0,
   180,   185,   129,   198,    63,     0,     0,   131,   198,   182,
   108,   228,    14,   225,   224,   184,   183,   233,     0,     0,
   183,    56,   184,     0,   185,   129,   190,     0,   186,     0,
   198,   187,     0,     0,    28,   188,     0,   231,   189,     0,
    68,     0,    97,     0,    88,     0,   123,     0,    81,     0,
     0,   193,   191,   192,     0,     0,   192,    45,   193,     0,
   210,     0,    92,     0,   212,     0,     0,   105,   196,     0,
     0,   109,   197,     0,   116,     0,    66,     0,   128,     0,
   199,     0,   200,     0,   201,     0,   202,     0,   203,     3,
   203,     0,   199,     3,   203,     0,   203,    23,   203,     0,
   200,    23,   203,     0,   203,     0,   203,    17,   203,     0,
   203,    20,   203,     0,   203,    25,   203,     0,   202,    25,
   203,     0,   204,     0,   204,   209,   204,     0,   205,     0,
   206,     0,   205,    36,   206,     0,   207,     0,   208,     0,
    21,   208,     0,   210,     0,   211,     0,   212,     0,     6,
     0,    18,     0,    54,     0,   116,     0,    48,     0,    78,
   198,   107,     0,   227,     0,   213,     0,   214,     0,   215,
     0,   227,    78,   231,   232,     0,   227,    78,   231,   152,
   231,   232,     0,   227,    37,   216,     0,   111,     0,    39,
     0,   132,     0,    82,     0,    40,     0,   133,     0,    83,
     0,   101,     0,   102,     0,    85,     0,    86,     0,     0,
    75,   219,   220,     0,     0,   220,    56,    75,     0,     0,
   230,     0,     0,   223,     0,    78,   198,   232,     0,     0,
   119,     0,     0,    72,     0,     0,   227,     0,    75,     0,
   212,     0,   230,    55,     0,    75,     0,    35,     0,   107,
     0,   113,     0,     5,     0
};

#endif

#if BVL_Y_DEBUG != 0
static const short bvl_y_rline[] = { 0,
  1556,  1637,  1647,  1655,  1663,  1671,  1672,  1680,  1685,  1692,
  1697,  1698,  1704,  1727,  1743,  1748,  1756,  1760,  1770,  1774,
  1775,  1788,  1793,  1799,  1804,  1811,  1829,  1831,  1836,  1837,
  1841,  1846,  1853,  1858,  1859,  1865,  1903,  1920,  1921,  1925,
  1927,  1929,  1931,  1936,  1946,  1955,  1961,  1965,  1966,  1971,
  1972,  1973,  1979,  2000,  2006,  2048,  2050,  2052,  2057,  2061,
  2062,  2067,  2068,  2069,  2070,  2076,  2089,  2102,  2106,  2116,
  2120,  2127,  2128,  2135,  2139,  2143,  2158,  2434,  2435,  2456,
  2463,  2730,  2732,  2753,  2769,  2774,  2783,  2785,  2791,  2810,
  2812,  2814,  2816,  2818,  2823,  2826,  2830,  2831,  2842,  2844,
  2846,  2917,  2919,  2925,  2927,  2933,  2938,  2940,  2945,  2947,
  2949,  2951,  2956,  2960,  2967,  2971,  2978,  2980,  2984,  2992,
  2996,  3003,  3005,  3012,  3017,  3019,  3027,  3032,  3034,  3040,
  3046,  3048,  3143,  3145,  3150,  3152,  3154,  3159,  3166,  3172,
  3174,  3176,  3181,  3193,  3211,  3275,  3279,  3281,  3283,  3285,
  3287,  3289,  3291,  3293,  3295,  3297,  3302,  3305,  3308,  3309,
  3316,  3318,  3323,  3325,  3330,  3337,  3339,  3344,  3346,  3351,
  3353,  3358,  3363,  3368,  3377,  3382,  3387,  3392,  3397
};
#endif


#if BVL_Y_DEBUG != 0 || defined (BVL_Y_ERROR_VERBOSE)

static const char * const bvl_y_tname[] = {   "$","error","$undefined.","_AND","_BEGIN",
"_END","_EQSym","_EXIT","_FILE","_GESym","_GTSym","_IN","_INOUT","_LABEL","_LESym",
"_LINKAGE","_LTSym","_NAND","_NESym","_NEXT","_NOR","_NOT","_NULL","_OR","_OUT",
"_XOR","ABS","ACCESS","AFTER","ALIAS","ALL","ARCHITECTURE","ARRAY","ASSERT",
"ATTRIBUTE","AbstractLit","Ampersand","Apostrophe","Arrow","BIT","BIT_VECTOR",
"BLOCK","BODY","BUFFER","BUS","Bar","BasedInt","BasedReal","BitStringLit","Box",
"CASE","COMPONENT","CONFIGURATION","CONSTANT","CharacterLit","Colon","Comma",
"DISCONNECT","DOWNTO","DecimalInt","DecimalReal","Dot","DoubleStar","ELSE","ELSIF",
"ENTITY","ERROR","FOR","FS","FUNCTION","GENERATE","GENERIC","GUARDED","IF","IS",
"Identifier","LIBRARY","LOOP","LeftParen","MAP","MOD","MS","MUX_BIT","MUX_VECTOR",
"Minus","NATURAL","NATURAL_VECTOR","NEW","NS","OF","ON","OPEN","OTHERS","PACKAGE",
"PORT","PROCEDURE","PROCESS","PS","Plus","RANGE","RECORD","REG_BIT","REG_VECTOR",
"REGISTER","REM","REPORT","RETURN","RightParen","SELECT","SEVERITY","SIGNAL",
"_STABLE","SUBTYPE","Semicolon","Slash","Star","StringLit","THEN","TO","TRANSPORT",
"_TYPE","UNITS","UNTIL","US","USE","VARIABLE","VarAsgn","WAIT","WARNING","WHEN",
"WHILE","WITH","WOR_BIT","WOR_VECTOR","design_file","@1","entity_declaration",
"@2",".generic_clause.","generic_clause","formal_generic_list","...formal_generic_element..",
"formal_generic_element","generic_VarAsgn__expression","generic_expression",
"generic_aggregate","@3","...generic_element_association..","generic_element_association",
".constraint.","constraint","range","direction",".port_clause.","port_clause",
"formal_port_list","...formal_port_element..","formal_port_element",".SIGNAL.",
".mode.","architecture_body","@4","architecture_declarative_part","..block_declarative_item..",
"block_declarative_item","constant_declaration","constant_VarAsgn__expression",
"signal_declaration",".signal_kind.","architecture_statement_part","..concurrent_statement..",
"concurrent_statement","block_statement","@5","set_of_statements","concurrent_assertion_statement",
"concurrent_signal_assignment_statement","unlabeled_concurrent_assertion_statement",
"assertion_statement","unlabeled_conditional_signal_assignment","..waveform__WHEN__condition__ELSE..",
"unlabeled_selected_signal_assignment","@6","...waveform__WHEN__choices..","waveform__WHEN__choices",
"waveform","waveform_element",".AFTER__delay_expression.","delay_expression",
"time_unit","choices","@7","..Bar__choice..","choice",".REPORT__expression.",
".SEVERITY__expression.","report__message","severity__message","expression",
"relation..AND__relation..","relation..OR__relation..","relation.NAND_NOR__relation.",
"relation..XOR__relation..","relation","simple_expression",".sign.term..add_op__term..",
"term","factor","primary","relational_operator","literal","aggregate","name",
"indexed_name","slice_name","attribute_name","attribute_designator","type_mark",
"identifier_list","@8","...identifier..",".label.",".guard_expression.","guard_expression",
".TRANSPORT.",".GUARDED.",".simple_name.","simple_name","target","a_label","label",
"abstractlit","RightParen_ERR","Semicolon_ERR","END_ERR", NULL
};
#endif

static const short bvl_y_r1[] = {     0,
   135,   134,   137,   136,   136,   138,   138,   139,   139,   140,
   141,   141,   142,   142,   143,   144,   144,   146,   145,   147,
   147,   148,   149,   149,   150,   151,   152,   152,   153,   153,
   154,   154,   155,   156,   156,   157,   157,   158,   158,   159,
   159,   159,   159,   161,   160,   160,   162,   163,   163,   164,
   164,   164,   165,   166,   167,   168,   168,   168,   169,   170,
   170,   171,   171,   171,   171,   173,   172,   174,   175,   175,
   176,   176,   176,   176,   177,   178,   179,   180,   180,   182,
   181,   183,   183,   184,   185,   186,   187,   187,   188,   189,
   189,   189,   189,   189,   191,   190,   192,   192,   193,   193,
   193,   194,   194,   195,   195,   196,   197,   197,   198,   198,
   198,   198,   199,   199,   200,   200,   201,   201,   201,   202,
   202,   203,   203,   204,   205,   205,   206,   207,   207,   208,
   208,   208,   209,   209,   210,   210,   210,   211,   212,   212,
   212,   212,   213,   214,   215,   216,   217,   217,   217,   217,
   217,   217,   217,   217,   217,   217,   219,   218,   220,   220,
   221,   221,   222,   222,   223,   224,   224,   225,   225,   226,
   226,   227,   228,   229,   230,   231,   232,   233,   234
};

static const short bvl_y_r2[] = {     0,
     0,     3,     0,     9,     2,     0,     1,     5,     3,     2,
     0,     3,     6,     1,     2,     1,     1,     0,     5,     0,
     3,     1,     0,     1,     3,     3,     1,     1,     0,     1,
     5,     3,     2,     0,     3,     7,     1,     0,     1,     0,
     1,     1,     1,     0,    12,     2,     1,     0,     2,     1,
     1,     2,     7,     2,     7,     0,     1,     1,     1,     0,
     2,     1,     1,     1,     2,     0,    10,     1,     2,     1,
     2,     1,     2,     1,     1,     5,     7,     0,     5,     0,
    11,     0,     3,     3,     1,     2,     0,     2,     2,     1,
     1,     1,     1,     1,     0,     3,     0,     3,     1,     1,
     1,     0,     2,     0,     2,     1,     1,     1,     1,     1,
     1,     1,     3,     3,     3,     3,     1,     3,     3,     3,
     3,     1,     3,     1,     1,     3,     1,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
     1,     1,     4,     6,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     0,     3,     0,     3,
     0,     1,     0,     1,     3,     0,     1,     0,     1,     0,
     1,     1,     1,     2,     1,     1,     1,     1,     1
};

static const short bvl_y_defact[] = {     1,
     0,     0,     0,     5,   172,     0,     0,     2,     3,    46,
     0,     6,     0,     0,    29,     7,     0,     0,     0,     0,
     0,    30,    44,   178,     9,    14,     0,     0,    11,     0,
     0,   179,   170,    48,   157,     0,   177,     0,    10,    32,
    37,    39,     0,    34,     0,     0,   171,     0,     0,   159,
     0,     8,     0,     0,    33,     0,     4,    60,     0,     0,
     0,    49,    51,    50,   158,   147,   150,   149,   152,   155,
   156,   153,   154,   148,   151,    23,    12,    31,     0,    40,
     0,     0,    52,     0,     0,     0,     0,     0,    24,    35,
    41,    43,    42,     0,   170,     0,     0,   172,     0,    61,
    62,    63,    64,    70,    75,    72,    74,   173,   140,   141,
   142,   139,     0,     0,     0,     0,     0,   160,   176,     0,
     0,     0,    13,    23,     0,    65,     0,   137,   135,     0,
   136,   102,   109,   110,   111,   112,   117,   122,   124,   125,
   127,   128,   130,   131,   132,    80,     0,     0,   168,   163,
    69,    71,    73,   174,    23,    23,    25,    28,    27,     0,
     0,    15,    17,    16,    56,    45,   129,     0,     0,   104,
     0,     0,     0,     0,     0,     0,     0,     0,   133,   134,
     0,     0,     0,   146,   145,     0,   169,   166,     0,     0,
   164,     0,    56,    26,    18,    22,    58,    57,    36,   138,
   106,   103,     0,     0,   114,   116,   121,   113,   118,   119,
   115,   120,   123,   126,     0,     0,   143,   167,    78,     0,
    66,     0,     0,     0,    20,   107,   108,   105,    76,     0,
     0,     0,   165,    60,    54,    53,    55,     0,   168,   144,
     0,    85,    87,     0,     0,     0,    19,   166,     0,    77,
     0,    86,     0,    21,     0,     0,    88,     0,   161,    82,
     0,    79,    90,    94,    92,    91,    93,    89,   175,     0,
   162,     0,     0,    67,     0,    81,   100,    84,    95,    99,
   101,    83,    97,    96,     0,    98,     0,     0,     0
};

static const short bvl_y_defgoto[] = {   287,
     1,     3,    12,    15,    16,    28,    39,    29,   123,   162,
   163,   225,   238,   195,    88,    89,   120,   160,    21,    22,
    43,    55,    44,    45,    94,     8,    34,    48,    49,    62,
    63,   223,    64,   199,    81,    82,   100,   101,   234,   245,
   102,   103,   104,   105,   106,   232,   107,   183,   272,   260,
   261,   242,   252,   257,   268,   278,   283,   284,   279,   170,
   204,   202,   228,   243,   133,   134,   135,   136,   137,   138,
   139,   140,   141,   142,   181,   143,   144,   145,   109,   110,
   111,   185,    76,    36,    50,    65,   270,   190,   191,   219,
   188,    46,   112,   113,   114,   115,   196,    38,    25,    33
};

static const short bvl_y_pact[] = {-32768,
     9,    29,    32,-32768,-32768,   -38,    31,-32768,-32768,-32768,
   -40,    21,     8,     4,    20,-32768,    23,    10,    52,    22,
   121,-32768,-32768,-32768,-32768,-32768,    55,    26,-32768,    10,
     5,-32768,     8,-32768,-32768,    80,-32768,    10,    10,-32768,
-32768,-32768,    26,-32768,    55,    10,-32768,   136,    14,-32768,
   -13,-32768,    52,    10,    10,    91,-32768,-32768,    10,    73,
    55,-32768,-32768,-32768,   101,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    81,-32768,-32768,     5,   117,
   121,     6,-32768,   103,   105,    86,   129,    39,-32768,-32768,
-32768,-32768,-32768,   -13,     8,    10,     0,   111,     0,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    47,   155,   -19,   115,   -13,   -13,-32768,-32768,    26,
    -1,   -16,-32768,    81,    10,-32768,   -20,-32768,-32768,     0,
-32768,    67,   168,   152,-32768,   151,   119,    59,   141,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    69,   129,   106,   104,
-32768,-32768,-32768,-32768,    81,    81,-32768,-32768,-32768,   129,
   129,-32768,-32768,-32768,    -2,-32768,-32768,    74,    68,    76,
     0,     0,     0,     0,     0,     0,     0,     0,-32768,-32768,
     0,     0,    75,-32768,-32768,     3,-32768,    70,     0,   182,
-32768,    61,    -2,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   -29,    10,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,     8,   129,-32768,-32768,-32768,    26,
-32768,    -8,    10,    10,-32768,-32768,-32768,-32768,-32768,   174,
    26,     0,-32768,-32768,-32768,-32768,-32768,    -4,   106,-32768,
   -69,-32768,   163,    12,   121,   129,-32768,    70,     0,-32768,
   129,-32768,   154,-32768,     0,   133,-32768,    50,   123,-32768,
    71,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    10,
-32768,    -6,    -7,-32768,     0,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   156,    -7,-32768,   199,   202,-32768
};

static const short bvl_y_pgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   150,-32768,-32768,
-32768,-32768,-32768,   -39,   -65,-32768,-32768,    19,-32768,-32768,
-32768,-32768,   127,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    15,-32768,   -25,-32768,-32768,-32768,-32768,
-32768,-32768,    96,-32768,    98,-32768,    99,-32768,-32768,   -61,
   -17,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -68,-32768,
-32768,-32768,-32768,   -87,-32768,-32768,-32768,-32768,   -22,    35,
-32768,    36,-32768,    92,-32768,  -187,-32768,   -81,-32768,-32768,
-32768,-32768,   -23,    66,-32768,-32768,-32768,-32768,-32768,   -28,
   -18,   128,    18,     7,-32768,   -35,   -84,   -41,   -30,   -77
};


#define	BVL_Y_LAST		242


static const short bvl_y_table[] = {    40,
   108,    54,   121,    95,    18,    41,    96,    52,    53,   132,
   -59,   146,    96,    97,    59,    57,   -68,   -47,   119,     6,
   127,   150,    30,    78,    79,    66,    67,   128,    83,     4,
    17,    10,   108,   129,   235,     9,   226,   164,    97,   128,
   128,   197,   168,    24,    97,   129,   129,   128,    13,   275,
    47,   246,    26,   129,     5,     5,   158,   130,   165,   249,
   158,   161,     7,   186,   179,   126,    60,     5,    68,    69,
   124,    70,    71,     2,     5,   194,   180,   130,   157,   -38,
    98,    19,     5,   147,   277,   280,    98,    72,    73,   192,
   193,    14,   155,   156,   166,   131,    23,   280,   227,    31,
   198,   220,    37,     5,    27,    11,    24,   131,   131,    37,
    56,    99,    47,    20,    42,   131,   159,   263,    74,    75,
   159,   174,    24,    61,   148,    32,    85,    91,    92,    35,
   264,   231,    37,   108,    51,   175,    99,   265,   176,    58,
    93,   177,    99,   178,   217,    80,   266,    84,   205,   206,
   207,   208,   209,   210,   211,   212,    86,   116,    87,   117,
   118,   256,   108,   119,   122,  -175,   258,   253,   149,   154,
   171,   169,   267,   229,   172,   173,   182,   187,   233,   184,
   200,   189,   215,   201,   203,   221,   222,   239,   218,   240,
   251,   281,   236,   237,   259,   262,   247,   269,   288,   273,
   285,   289,    77,   281,   216,    90,   254,   224,   244,   151,
   250,   152,   153,   282,   241,   213,   286,   214,   167,   255,
   248,   230,   125,   271,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   274,
     0,   276
};

static const short bvl_y_check[] = {    30,
    82,    43,    87,    81,     1,     1,     1,    38,    39,    97,
     5,    99,     1,    33,     1,    46,     5,     4,    35,     2,
    21,    41,     1,    54,    55,    39,    40,    48,    59,     1,
    13,     1,   114,    54,   222,    74,    66,   122,    33,    48,
    48,    44,   130,   113,    33,    54,    54,    48,    89,    56,
    33,    56,     1,    54,    75,    75,    58,    78,   124,   129,
    58,    78,    31,   148,     6,    96,    53,    75,    82,    83,
    94,    85,    86,    65,    75,   160,    18,    78,   120,    75,
    75,    78,    75,    37,    92,   273,    75,   101,   102,   155,
   156,    71,   116,   117,   125,   116,    74,   285,   128,    78,
   103,   189,   107,    75,    53,    75,   113,   116,   116,   107,
    45,   131,    95,    94,   110,   116,   118,    68,   132,   133,
   118,     3,   113,   110,    78,     5,    61,    11,    12,    75,
    81,   216,   107,   215,    55,    17,   131,    88,    20,     4,
    24,    23,   131,    25,   186,    55,    97,    75,   171,   172,
   173,   174,   175,   176,   177,   178,    56,    55,    78,    55,
    75,   249,   244,    35,   126,    55,   251,   245,    14,    55,
     3,   105,   123,   204,    23,    25,    36,    72,   220,   111,
   107,    78,   108,   116,   109,     4,   126,    14,   119,   231,
    28,   273,   223,   224,    41,    63,   238,    75,     0,   129,
    45,     0,    53,   285,   186,    79,   246,   193,   234,   114,
   241,   114,   114,   275,   232,   181,   285,   182,   127,   248,
   239,   215,    95,   259,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   270,
    -1,   272
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/freeware/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef BVL_Y_STACK_USE_ALLOCA
#ifdef alloca
#define BVL_Y_STACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define BVL_Y_STACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define BVL_Y_STACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define BVL_Y_STACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define BVL_Y_STACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* BVL_Y_STACK_USE_ALLOCA not defined */

#ifdef BVL_Y_STACK_USE_ALLOCA
#define BVL_Y_STACK_ALLOC alloca
#else
#define BVL_Y_STACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define bvl_y_errok		(bvl_y_errstatus = 0)
#define bvl_y_clearin	(bvl_y_char = BVL_Y_EMPTY)
#define BVL_Y_EMPTY		-2
#define BVL_Y_EOF		0
#define BVL_Y_ACCEPT	goto bvl_y_acceptlab
#define BVL_Y_ABORT 	goto bvl_y_abortlab
#define BVL_Y_ERROR		goto bvl_y_errlab1
/* Like BVL_Y_ERROR except do call bvl_y_error.
   This remains here temporarily to ease the
   transition to the new meaning of BVL_Y_ERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define BVL_Y_FAIL		goto bvl_y_errlab
#define BVL_Y_RECOVERING()  (!!bvl_y_errstatus)
#define BVL_Y_BACKUP(token, value) \
do								\
  if (bvl_y_char == BVL_Y_EMPTY && bvl_y_len == 1)				\
    { bvl_y_char = (token), bvl_y_lval = (value);			\
      bvl_y_char1 = BVL_Y_TRANSLATE (bvl_y_char);				\
      BVL_Y_POPSTACK;						\
      goto bvl_y_backup;						\
    }								\
  else								\
    { bvl_y_error ("syntax error: cannot back up"); BVL_Y_ERROR; }	\
while (0)

#define BVL_Y_TERROR	1
#define BVL_Y_ERRCODE	256

#ifndef BVL_Y_PURE
#define BVL_Y_LEX		bvl_y_lex()
#endif

#ifdef BVL_Y_PURE
#ifdef BVL_Y_LSP_NEEDED
#ifdef BVL_Y_LEX_PARAM
#define BVL_Y_LEX		bvl_y_lex(&bvl_y_lval, &bvl_y_lloc, BVL_Y_LEX_PARAM)
#else
#define BVL_Y_LEX		bvl_y_lex(&bvl_y_lval, &bvl_y_lloc)
#endif
#else /* not BVL_Y_LSP_NEEDED */
#ifdef BVL_Y_LEX_PARAM
#define BVL_Y_LEX		bvl_y_lex(&bvl_y_lval, BVL_Y_LEX_PARAM)
#else
#define BVL_Y_LEX		bvl_y_lex(&bvl_y_lval)
#endif
#endif /* not BVL_Y_LSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef BVL_Y_PURE

int	bvl_y_char;			/*  the lookahead symbol		*/
BVL_Y_STYPE	bvl_y_lval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef BVL_Y_LSP_NEEDED
BVL_Y_LTYPE bvl_y_lloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int bvl_y_nerrs;			/*  number of parse errors so far       */
#endif  /* not BVL_Y_PURE */

#if BVL_Y_DEBUG != 0
int bvl_y_debug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  BVL_Y_INITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	BVL_Y_INITDEPTH
#define BVL_Y_INITDEPTH 200
#endif

/*  BVL_Y_MAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if BVL_Y_MAXDEPTH == 0
#undef BVL_Y_MAXDEPTH
#endif

#ifndef BVL_Y_MAXDEPTH
#define BVL_Y_MAXDEPTH 10000
#endif

/* Define __bvl_y__memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __bvl_y__memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__bvl_y__memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__bvl_y__memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/freeware/share/bison.simple"

/* The user can define BVL_Y_PARSE_PARAM as the name of an argument to be passed
   into bvl_y_parse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef BVL_Y_PARSE_PARAM
#ifdef __cplusplus
#define BVL_Y_PARSE_PARAM_ARG void *BVL_Y_PARSE_PARAM
#define BVL_Y_PARSE_PARAM_DECL
#else /* not __cplusplus */
#define BVL_Y_PARSE_PARAM_ARG BVL_Y_PARSE_PARAM
#define BVL_Y_PARSE_PARAM_DECL void *BVL_Y_PARSE_PARAM;
#endif /* not __cplusplus */
#else /* not BVL_Y_PARSE_PARAM */
#define BVL_Y_PARSE_PARAM_ARG
#define BVL_Y_PARSE_PARAM_DECL
#endif /* not BVL_Y_PARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef BVL_Y_PARSE_PARAM
int bvl_y_parse (void *);
#else
int bvl_y_parse (void);
#endif
#endif

int
bvl_y_parse(BVL_Y_PARSE_PARAM_ARG)
     BVL_Y_PARSE_PARAM_DECL
{
  register int bvl_y_state;
  register int bvl_y_n;
  register short *bvl_y_ssp;
  register BVL_Y_STYPE *bvl_y_vsp;
  int bvl_y_errstatus;	/*  number of tokens to shift before error messages enabled */
  int bvl_y_char1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	bvl_y_ssa[BVL_Y_INITDEPTH];	/*  the state stack			*/
  BVL_Y_STYPE bvl_y_vsa[BVL_Y_INITDEPTH];	/*  the semantic value stack		*/

  short *bvl_y_ss = bvl_y_ssa;		/*  refer to the stacks thru separate pointers */
  BVL_Y_STYPE *bvl_y_vs = bvl_y_vsa;	/*  to allow bvl_y_overflow to reallocate them elsewhere */

#ifdef BVL_Y_LSP_NEEDED
  BVL_Y_LTYPE bvl_y_lsa[BVL_Y_INITDEPTH];	/*  the location stack			*/
  BVL_Y_LTYPE *bvl_y_ls = bvl_y_lsa;
  BVL_Y_LTYPE *bvl_y_lsp;

#define BVL_Y_POPSTACK   (bvl_y_vsp--, bvl_y_ssp--, bvl_y_lsp--)
#else
#define BVL_Y_POPSTACK   (bvl_y_vsp--, bvl_y_ssp--)
#endif

  int bvl_y_stacksize = BVL_Y_INITDEPTH;
  int bvl_y_free_stacks = 0;

#ifdef BVL_Y_PURE
  int bvl_y_char;
  BVL_Y_STYPE bvl_y_lval;
  int bvl_y_nerrs;
#ifdef BVL_Y_LSP_NEEDED
  BVL_Y_LTYPE bvl_y_lloc;
#endif
#endif

  BVL_Y_STYPE bvl_y_val;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int bvl_y_len;

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    fprintf(stderr, "Starting parse\n");
#endif

  bvl_y_state = 0;
  bvl_y_errstatus = 0;
  bvl_y_nerrs = 0;
  bvl_y_char = BVL_Y_EMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  bvl_y_ssp = bvl_y_ss - 1;
  bvl_y_vsp = bvl_y_vs;
#ifdef BVL_Y_LSP_NEEDED
  bvl_y_lsp = bvl_y_ls;
#endif

/* Push a new state, which is found in  bvl_y_state  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
bvl_y_newstate:

  *++bvl_y_ssp = bvl_y_state;

  if (bvl_y_ssp >= bvl_y_ss + bvl_y_stacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      BVL_Y_STYPE *bvl_y_vs1 = bvl_y_vs;
      short *bvl_y_ss1 = bvl_y_ss;
#ifdef BVL_Y_LSP_NEEDED
      BVL_Y_LTYPE *bvl_y_ls1 = bvl_y_ls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = bvl_y_ssp - bvl_y_ss + 1;

#ifdef bvl_y_overflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef BVL_Y_LSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if bvl_y_overflow is a macro.  */
      bvl_y_overflow("parser stack overflow",
		 &bvl_y_ss1, size * sizeof (*bvl_y_ssp),
		 &bvl_y_vs1, size * sizeof (*bvl_y_vsp),
		 &bvl_y_ls1, size * sizeof (*bvl_y_lsp),
		 &bvl_y_stacksize);
#else
      bvl_y_overflow("parser stack overflow",
		 &bvl_y_ss1, size * sizeof (*bvl_y_ssp),
		 &bvl_y_vs1, size * sizeof (*bvl_y_vsp),
		 &bvl_y_stacksize);
#endif

      bvl_y_ss = bvl_y_ss1; bvl_y_vs = bvl_y_vs1;
#ifdef BVL_Y_LSP_NEEDED
      bvl_y_ls = bvl_y_ls1;
#endif
#else /* no bvl_y_overflow */
      /* Extend the stack our own way.  */
      if (bvl_y_stacksize >= BVL_Y_MAXDEPTH)
	{
	  bvl_y_error("parser stack overflow");
	  if (bvl_y_free_stacks)
	    {
	      free (bvl_y_ss);
	      free (bvl_y_vs);
#ifdef BVL_Y_LSP_NEEDED
	      free (bvl_y_ls);
#endif
	    }
	  return 2;
	}
      bvl_y_stacksize *= 2;
      if (bvl_y_stacksize > BVL_Y_MAXDEPTH)
	bvl_y_stacksize = BVL_Y_MAXDEPTH;
#ifndef BVL_Y_STACK_USE_ALLOCA
      bvl_y_free_stacks = 1;
#endif
      bvl_y_ss = (short *) BVL_Y_STACK_ALLOC (bvl_y_stacksize * sizeof (*bvl_y_ssp));
      __bvl_y__memcpy ((char *)bvl_y_ss, (char *)bvl_y_ss1,
		   size * (unsigned int) sizeof (*bvl_y_ssp));
      bvl_y_vs = (BVL_Y_STYPE *) BVL_Y_STACK_ALLOC (bvl_y_stacksize * sizeof (*bvl_y_vsp));
      __bvl_y__memcpy ((char *)bvl_y_vs, (char *)bvl_y_vs1,
		   size * (unsigned int) sizeof (*bvl_y_vsp));
#ifdef BVL_Y_LSP_NEEDED
      bvl_y_ls = (BVL_Y_LTYPE *) BVL_Y_STACK_ALLOC (bvl_y_stacksize * sizeof (*bvl_y_lsp));
      __bvl_y__memcpy ((char *)bvl_y_ls, (char *)bvl_y_ls1,
		   size * (unsigned int) sizeof (*bvl_y_lsp));
#endif
#endif /* no bvl_y_overflow */

      bvl_y_ssp = bvl_y_ss + size - 1;
      bvl_y_vsp = bvl_y_vs + size - 1;
#ifdef BVL_Y_LSP_NEEDED
      bvl_y_lsp = bvl_y_ls + size - 1;
#endif

#if BVL_Y_DEBUG != 0
      if (bvl_y_debug)
	fprintf(stderr, "Stack size increased to %d\n", bvl_y_stacksize);
#endif

      if (bvl_y_ssp >= bvl_y_ss + bvl_y_stacksize - 1)
	BVL_Y_ABORT;
    }

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    fprintf(stderr, "Entering state %d\n", bvl_y_state);
#endif

  goto bvl_y_backup;
 bvl_y_backup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* bvl_y_resume: */

  /* First try to decide what to do without reference to lookahead token.  */

  bvl_y_n = bvl_y_pact[bvl_y_state];
  if (bvl_y_n == BVL_Y_FLAG)
    goto bvl_y_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* bvl_y_char is either BVL_Y_EMPTY or BVL_Y_EOF
     or a valid token in external form.  */

  if (bvl_y_char == BVL_Y_EMPTY)
    {
#if BVL_Y_DEBUG != 0
      if (bvl_y_debug)
	fprintf(stderr, "Reading a token: ");
#endif
      bvl_y_char = BVL_Y_LEX;
    }

  /* Convert token to internal form (in bvl_y_char1) for indexing tables with */

  if (bvl_y_char <= 0)		/* This means end of input. */
    {
      bvl_y_char1 = 0;
      bvl_y_char = BVL_Y_EOF;		/* Don't call BVL_Y_LEX any more */

#if BVL_Y_DEBUG != 0
      if (bvl_y_debug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      bvl_y_char1 = BVL_Y_TRANSLATE(bvl_y_char);

#if BVL_Y_DEBUG != 0
      if (bvl_y_debug)
	{
	  fprintf (stderr, "Next token is %d (%s", bvl_y_char, bvl_y_tname[bvl_y_char1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef BVL_Y_PRINT
	  BVL_Y_PRINT (stderr, bvl_y_char, bvl_y_lval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  bvl_y_n += bvl_y_char1;
  if (bvl_y_n < 0 || bvl_y_n > BVL_Y_LAST || bvl_y_check[bvl_y_n] != bvl_y_char1)
    goto bvl_y_default;

  bvl_y_n = bvl_y_table[bvl_y_n];

  /* bvl_y_n is what to do for this token type in this state.
     Negative => reduce, -bvl_y_n is rule number.
     Positive => shift, bvl_y_n is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (bvl_y_n < 0)
    {
      if (bvl_y_n == BVL_Y_FLAG)
	goto bvl_y_errlab;
      bvl_y_n = -bvl_y_n;
      goto bvl_y_reduce;
    }
  else if (bvl_y_n == 0)
    goto bvl_y_errlab;

  if (bvl_y_n == BVL_Y_FINAL)
    BVL_Y_ACCEPT;

  /* Shift the lookahead token.  */

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    fprintf(stderr, "Shifting token %d (%s), ", bvl_y_char, bvl_y_tname[bvl_y_char1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (bvl_y_char != BVL_Y_EOF)
    bvl_y_char = BVL_Y_EMPTY;

  *++bvl_y_vsp = bvl_y_lval;
#ifdef BVL_Y_LSP_NEEDED
  *++bvl_y_lsp = bvl_y_lloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (bvl_y_errstatus) bvl_y_errstatus--;

  bvl_y_state = bvl_y_n;
  goto bvl_y_newstate;

/* Do the default action for the current state.  */
bvl_y_default:

  bvl_y_n = bvl_y_defact[bvl_y_state];
  if (bvl_y_n == 0)
    goto bvl_y_errlab;

/* Do a reduction.  bvl_y_n is the number of a rule to reduce with.  */
bvl_y_reduce:
  bvl_y_len = bvl_y_r2[bvl_y_n];
  if (bvl_y_len > 0)
    bvl_y_val = bvl_y_vsp[1-bvl_y_len]; /* implement default value of the action */

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       bvl_y_n, bvl_y_rline[bvl_y_n]);

      /* Print the symbols being reduced, and their result.  */
      for (i = bvl_y_prhs[bvl_y_n]; bvl_y_rhs[i] > 0; i++)
	fprintf (stderr, "%s ", bvl_y_tname[bvl_y_rhs[i]]);
      fprintf (stderr, " -> %s\n", bvl_y_tname[bvl_y_r1[bvl_y_n]]);
    }
#endif


  switch (bvl_y_n) {

case 1:
#line 1557 "bvl_bcomp.yac"
{
		/* ###----------------------------------------------### */
		/*    Initializations					*/
		/*      - initialize the time unit conversion variables	*/
		/*      - erroneous  description presumed !		*/
		/*      - zero delay description presumed !		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = NULL;
		BVL_GRDLST = NULL;
		BVL_CNDLST = NULL;
		BVL_VALLST = NULL;
		BVL_ERRFLG = 0;
		switch (BEH_TIMEUNIT)
		  {
		  case BEH_TU__FS :
		    BVL_CNVFS = 1      ;
		    BVL_CNVPS = 1.0E+3 ;
		    BVL_CNVNS = 1.0E+6 ;
		    BVL_CNVUS = 1.0E+9 ;
		    BVL_CNVMS = 1.0E+12;
		    break;

		  case BEH_TU__PS :
		    BVL_CNVFS = 1.0E-3 ;
		    BVL_CNVPS = 1      ;
		    BVL_CNVNS = 1.0E+3 ;
		    BVL_CNVUS = 1.0E+6 ;
		    BVL_CNVMS = 1.0E+9 ;
		    break;

		  case BEH_TU__NS :
		    BVL_CNVFS = 1.0E-6 ;
		    BVL_CNVPS = 1.0E-3 ;
		    BVL_CNVNS = 1      ;
		    BVL_CNVUS = 1.0E+3 ;
		    BVL_CNVMS = 1.0E+6 ;
		    break;

		  case BEH_TU__US :
		    BVL_CNVFS = 1.0E-9 ;
		    BVL_CNVPS = 1.0E-6 ;
		    BVL_CNVNS = 1.0E-3 ;
		    BVL_CNVUS = 1      ;
		    BVL_CNVMS = 1.0E+3 ;
		    break;

		  case BEH_TU__MS :
		    BVL_CNVFS = 1.0E-12;
		    BVL_CNVPS = 1.0E-9 ;
		    BVL_CNVNS = 1.0E-6 ;
		    BVL_CNVUS = 1.0E-3 ;
		    BVL_CNVMS = 1      ;
		    break;

		  default :
		    BVL_CNVFS = 1      ;
		    BVL_CNVPS = 1      ;
		    BVL_CNVNS = 1      ;
		    BVL_CNVUS = 1      ;
		    BVL_CNVMS = 1      ;
		    bvl_error (83, NULL);
		  }

		if (BVL_ERRFLG == 0)
		  {
		  BVL_CNVFS = BVL_CNVFS / BEH_TIMESTEP;
		  BVL_CNVPS = BVL_CNVPS / BEH_TIMESTEP;
		  BVL_CNVNS = BVL_CNVNS / BEH_TIMESTEP;
		  BVL_CNVUS = BVL_CNVUS / BEH_TIMESTEP;
		  BVL_CNVMS = BVL_CNVMS / BEH_TIMESTEP;
		  }

		dic                 = beh_initab ();
		BVL_BEFPNT          = beh_addbefig (BVL_HEDFIG, NULL);
		BVL_BEFPNT->FLAG   |= BEH_FIG_ZERODELAY;
		BVL_BEFPNT->ERRFLG  = 1;
		BVL_HEDFIG          = BVL_BEFPNT;
		;
    break;}
case 2:
#line 1638 "bvl_bcomp.yac"
{
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->ERRFLG = 0;

		beh_fretab (dic);
		;
    break;}
case 3:
#line 1650 "bvl_bcomp.yac"
{
		BVL_BEFPNT->NAME = bvl_y_vsp[-1].text;
		BVL_MODNAM       = bvl_y_vsp[-1].text;
		;
    break;}
case 4:
#line 1659 "bvl_bcomp.yac"
{
		if ((bvl_y_vsp[-1].text != NULL) && (bvl_y_vsp[-1].text != bvl_y_vsp[-7].text))
		  bvl_error (1, bvl_y_vsp[-1].text);
		;
    break;}
case 5:
#line 1665 "bvl_bcomp.yac"
{
		bvl_error (2, NULL);
		;
    break;}
case 7:
#line 1673 "bvl_bcomp.yac"
{
		BVL_BEFPNT->BEGEN = BVL_GENPNT;
		BVL_GENPNT        = NULL      ;
		;
    break;}
case 9:
#line 1688 "bvl_bcomp.yac"
{ bvl_error (74, NULL); ;
    break;}
case 13:
#line 1710 "bvl_bcomp.yac"
{
		char *type;

		if (bvl_y_vsp[-1].name.FLAG == bvl_y_vsp[-2].dble.FLAG)
		  {
		  BVL_NM1LST = reverse   (BVL_NM1LST);
		  type       = namealloc ("natural");
		  BVL_GENPNT = addgen (BVL_GENPNT, BVL_INTLST, BVL_NM1LST,
		                       type, bvl_y_vsp[-1].name.LEFT, bvl_y_vsp[-1].name.RIGHT);
		  }
		else
		  bvl_error (33, NULL);
		freechain (BVL_NM1LST);
		freechain (BVL_INTLST);
		BVL_NM1LST = NULL;
		BVL_INTLST = NULL;
		;
    break;}
case 14:
#line 1728 "bvl_bcomp.yac"
{
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  bvl_y_char = bvl_y_lex ();
		while ((bvl_y_char != Semicolon) && (bvl_y_char != 0));
		bvl_y_errok;
		bvl_error (75, NULL);
		;
    break;}
case 16:
#line 1749 "bvl_bcomp.yac"
{
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = bvl_y_vsp[0].valu;
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		;
    break;}
case 18:
#line 1762 "bvl_bcomp.yac"
{
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = bvl_y_vsp[0].valu;
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		;
    break;}
case 21:
#line 1778 "bvl_bcomp.yac"
{
		long *ptlong;

		ptlong = (long *) mbkalloc (sizeof(long));
		*ptlong = bvl_y_vsp[0].valu;
		BVL_INTLST = addchain (BVL_INTLST, (void *)ptlong);
		;
    break;}
case 22:
#line 1789 "bvl_bcomp.yac"
{bvl_y_val.valu = bvl_y_vsp[0].valu;;
    break;}
case 23:
#line 1794 "bvl_bcomp.yac"
{
		bvl_y_val.name.FLAG  = 'S';
		bvl_y_val.name.LEFT  = -1;
		bvl_y_val.name.RIGHT = -1;
		;
    break;}
case 24:
#line 1800 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[0].name; ;
    break;}
case 25:
#line 1807 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[-1].name; ;
    break;}
case 26:
#line 1814 "bvl_bcomp.yac"
{
		bvl_y_val.name.FLAG  = 'A';
		bvl_y_val.name.LEFT  = bvl_y_vsp[-2].valu;
		bvl_y_val.name.RIGHT = bvl_y_vsp[0].valu;

		if (((bvl_y_vsp[-2].valu > bvl_y_vsp[0].valu) && (bvl_y_vsp[-1].valu == BVL_UPTDFN)) ||
		    ((bvl_y_vsp[-2].valu < bvl_y_vsp[0].valu) && (bvl_y_vsp[-1].valu == BVL_DWTDFN)) ||
		    ((bvl_y_vsp[-2].valu < 0 ) || (bvl_y_vsp[-1].valu < 0 )))
		  {
		  bvl_error (32, NULL);
		  }
		;
    break;}
case 27:
#line 1830 "bvl_bcomp.yac"
{ bvl_y_val.valu = BVL_UPTDFN; ;
    break;}
case 28:
#line 1832 "bvl_bcomp.yac"
{ bvl_y_val.valu = BVL_DWTDFN; ;
    break;}
case 32:
#line 1849 "bvl_bcomp.yac"
{ bvl_error (3, NULL); ;
    break;}
case 36:
#line 1872 "bvl_bcomp.yac"
{
		char *signame;
		int   sigconf;
		void *pnt;

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each port, create the apropriate set of	*/
		/* structures (berin, bepor, beout, bebus)		*/
		/* ###----------------------------------------------### */

		chkdcl ('P', bvl_y_vsp[-3].valu, bvl_y_vsp[-2].dble.VALU, bvl_y_vsp[-2].dble.FLAG, bvl_y_vsp[0].valu, bvl_y_vsp[-1].name.FLAG, &sigconf);

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic, signame, BVL_MODNAM, BVL_SIGDFN) != 0)
		    bvl_error (4, signame);

		  pnt = addstr (BVL_BEFPNT, 'P', bvl_y_vsp[-3].valu, bvl_y_vsp[-2].dble.VALU, bvl_y_vsp[-2].dble.FLAG, signame,
		                bvl_y_vsp[-1].name.LEFT, bvl_y_vsp[-1].name.RIGHT);

		  beh_addtab (dic, signame, BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMNDFN, bvl_y_vsp[-1].name.LEFT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMXDFN, bvl_y_vsp[-1].name.RIGHT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_PNTDFN, (int)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		;
    break;}
case 37:
#line 1904 "bvl_bcomp.yac"
{
		/* ###----------------------------------------------### */
		/*   The following 3 lines reject tokens until the	*/
		/* sync. token 'Semicolon' is found			*/
		/* ###----------------------------------------------### */

		do
		  bvl_y_char = bvl_y_lex ();
		while ((bvl_y_char != Semicolon) && (bvl_y_char != 0));
		bvl_y_errok;

		bvl_error (6, NULL);
		;
    break;}
case 40:
#line 1926 "bvl_bcomp.yac"
{ bvl_y_val.valu = _IN; ;
    break;}
case 41:
#line 1928 "bvl_bcomp.yac"
{ bvl_y_val.valu = _IN; ;
    break;}
case 42:
#line 1930 "bvl_bcomp.yac"
{ bvl_y_val.valu = _OUT; ;
    break;}
case 43:
#line 1932 "bvl_bcomp.yac"
{ bvl_y_val.valu = _INOUT; ;
    break;}
case 44:
#line 1941 "bvl_bcomp.yac"
{
		if (bvl_y_vsp[-1].text != BVL_MODNAM)
		  bvl_error (1, bvl_y_vsp[-1].text);
		;
    break;}
case 45:
#line 1951 "bvl_bcomp.yac"
{
		if ((bvl_y_vsp[-1].text != NULL) && (bvl_y_vsp[-1].text != bvl_y_vsp[-10].text))
		  bvl_error (7, bvl_y_vsp[-1].text);
		;
    break;}
case 46:
#line 1957 "bvl_bcomp.yac"
{ bvl_error (8, NULL); ;
    break;}
case 52:
#line 1975 "bvl_bcomp.yac"
{ bvl_error (9, NULL); ;
    break;}
case 53:
#line 1986 "bvl_bcomp.yac"
{
		int sigconf;
		
		if (chkdcl ('C', 0, bvl_y_vsp[-3].dble.VALU, bvl_y_vsp[-3].dble.FLAG, 0, bvl_y_vsp[-2].name.FLAG, &sigconf)==0)
		  {
		  beh_addtab (dic, bvl_y_vsp[-5].text, BVL_MODNAM, BVL_WMNDFN, bvl_y_vsp[-2].name.LEFT);
		  beh_addtab (dic, bvl_y_vsp[-5].text, BVL_MODNAM, BVL_WMXDFN, bvl_y_vsp[-2].name.RIGHT);
		  beh_addtab (dic, bvl_y_vsp[-5].text, BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, bvl_y_vsp[-5].text, NULL, BVL_PNTDFN, bvl_y_vsp[-1].text);
		  }
		;
    break;}
case 54:
#line 2002 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 55:
#line 2013 "bvl_bcomp.yac"
{
		char *signame;
		int   sigconf;
		void *pnt;
		int   errflg;

		errflg = chkdcl ('S',0,bvl_y_vsp[-3].dble.VALU,bvl_y_vsp[-3].dble.FLAG,bvl_y_vsp[-1].valu,bvl_y_vsp[-2].name.FLAG,&sigconf);

		/* ###----------------------------------------------### */
		/*    First, check the validity of the declaration.	*/
		/* Then, for each signal, create the apropriate set of	*/
		/* structures (berin, bereg, beaux, bebux)		*/
		/* ###----------------------------------------------### */

		BVL_NM1LST = reverse (BVL_NM1LST);
		while (BVL_NM1LST != NULL)
		  {
		  signame = (char *)BVL_NM1LST->DATA;
		  if (beh_chktab (dic, signame, BVL_MODNAM, BVL_SIGDFN) != 0)
		    bvl_error (10, signame);

		  pnt = addstr (BVL_BEFPNT, 'S', 0, bvl_y_vsp[-3].dble.VALU, bvl_y_vsp[-3].dble.FLAG, signame,
		                bvl_y_vsp[-2].name.LEFT, bvl_y_vsp[-2].name.RIGHT);

		  beh_addtab (dic, signame, BVL_MODNAM, BVL_SIGDFN, sigconf);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMNDFN, bvl_y_vsp[-2].name.LEFT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_WMXDFN, bvl_y_vsp[-2].name.RIGHT);
		  beh_addtab (dic, signame, BVL_MODNAM, BVL_PNTDFN, (int)pnt);

		  BVL_NM1LST = delchain (BVL_NM1LST, BVL_NM1LST);
		  }
		;
    break;}
case 56:
#line 2049 "bvl_bcomp.yac"
{ bvl_y_val.valu = 0; ;
    break;}
case 57:
#line 2051 "bvl_bcomp.yac"
{ bvl_y_val.valu = REGISTER; ;
    break;}
case 58:
#line 2053 "bvl_bcomp.yac"
{ bvl_y_val.valu = BUS; ;
    break;}
case 65:
#line 2072 "bvl_bcomp.yac"
{ bvl_error (18, NULL); ;
    break;}
case 66:
#line 2080 "bvl_bcomp.yac"
{
		if (beh_chktab (dic, bvl_y_vsp[-3].text, BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, bvl_y_vsp[-3].text);

		beh_addtab (dic, bvl_y_vsp[-3].text, BVL_MODNAM, BVL_LBLDFN, 1);
		if (bvl_y_vsp[-1].text != NULL)
		  BVL_GRDLST = addchain (BVL_GRDLST, (char *)bvl_y_vsp[-1].text);
		;
    break;}
case 67:
#line 2093 "bvl_bcomp.yac"
{
		if (bvl_y_vsp[-7].text != NULL)
		  BVL_GRDLST = delchain (BVL_GRDLST, BVL_GRDLST);
		if ((bvl_y_vsp[-1].text != NULL) && (bvl_y_vsp[-1].text != bvl_y_vsp[-9].text))
		  bvl_error (20, bvl_y_vsp[-1].text);
		;
    break;}
case 69:
#line 2108 "bvl_bcomp.yac"
{
		if (beh_chktab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, bvl_y_vsp[-1].text);

		beh_addtab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN, 1);
		if (BVL_ERRFLG == 0)
		  BVL_BEFPNT->BEMSG->LABEL = bvl_y_vsp[-1].text;
		;
    break;}
case 71:
#line 2122 "bvl_bcomp.yac"
{
		if (beh_chktab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, bvl_y_vsp[-1].text);
		beh_addtab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN, 1);
		;
    break;}
case 73:
#line 2130 "bvl_bcomp.yac"
{
		if (beh_chktab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN) != 0)
		  bvl_error (19, bvl_y_vsp[-1].text);
		beh_addtab (dic, bvl_y_vsp[-1].text, BVL_MODNAM, BVL_LBLDFN, 1);
		;
    break;}
case 76:
#line 2148 "bvl_bcomp.yac"
{
		if (BVL_ERRFLG == 0)
		  {
		  BVL_BEFPNT->BEMSG = beh_addbemsg(BVL_BEFPNT->BEMSG, NULL, bvl_y_vsp[-1].valu,
		                                   bvl_y_vsp[-2].text, bvl_y_vsp[-3].list.LIST_ABL->DATA, NULL);
		  }
		;
    break;}
case 77:
#line 2165 "bvl_bcomp.yac"
{
		int             i        ;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt  ;
		unsigned long   delay    ;
		struct bvl_expr expr0    ;
		struct bvl_expr expr1    ;
		struct bvl_expr expr2    ;
		struct bvl_expr expr3    ;
		struct bvl_expr expr4    ;
		struct bvl_expr expr5    ;
		struct bvl_expr expr6    ;
		int             rev_flg  = 0;
		int             left_bnd ;
		int             right_bnd;
		int             left     ;
		int             right    ;
		int             in_bound ;
		int             out_bound;
		int             sig_width;
		int             sig_conf ;

		delay = bvl_y_vsp[-1].list.TIME;
		expr4 = bvl_y_vsp[-1].list     ;

		while (BVL_CNDLST != NULL)
		  {
		  expr5 = *((bvl_ablstr *) BVL_CNDLST->DATA);
		  expr6 = *((bvl_ablstr *) BVL_VALLST->DATA);

		  expr0 = cpyablstr (expr5);
		  expr1 = crtabl (NOT , expr5, BVL_EMPSTR, -1, -1);
		  expr5 = expr0;
		  expr2 = crtabl (ANDM, expr4, expr1     , -1, -1);
		  expr3 = crtabl (ANDM, expr6, expr5     , -1, -1);
		  expr4 = crtabl (OR  , expr2, expr3     , -1, -1);

		  BVL_CNDLST = delchain (BVL_CNDLST, BVL_CNDLST);
		  BVL_VALLST = delchain (BVL_VALLST, BVL_VALLST);
		  }

		left_bnd  = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_WMXDFN);
		sig_conf  = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_SIGDFN);

		left  = bvl_y_vsp[-6].name.LEFT ;
		right = bvl_y_vsp[-6].name.RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left ;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left ;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr4.WIDTH)
		  bvl_error (35, bvl_y_vsp[-6].name.NAME);

		if (rev_flg == 1)
		  expr4.LIST_ABL = reverse (expr4.LIST_ABL);

		abl_pnt = expr4.LIST_ABL;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21, bvl_y_vsp[-6].name.NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if (bvl_y_vsp[-4].valu == BVL_GRDDFN)
		      bvl_error (22, bvl_y_vsp[-6].name.NAME);
		    beout_pnt = (struct beout *)
		                 beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39, beout_pnt->NAME);
		          else
		            {
		            beout_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beout_pnt->TIME = delay;
		            beout_pnt->FLAG = bvl_y_vsp[-3].valu   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bebus_pnt = (struct bebus *)
		                 beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL, NULL);
		          bebus_pnt->BINODE->TIME = delay;
		          bebus_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebus_pnt->BIABL->TIME = delay;
		          bebus_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if (bvl_y_vsp[-4].valu == BVL_GRDDFN)
		      bvl_error (22, bvl_y_vsp[-6].name.NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39, beaux_pnt->NAME);
		          else
		            {
		            beaux_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beaux_pnt->TIME = delay;
		            beaux_pnt->FLAG = bvl_y_vsp[-3].valu   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL, NULL);
		          bereg_pnt->BINODE->TIME = delay;
		          bereg_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bereg_pnt->BIABL->TIME = delay;
		          bereg_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL, NULL);
		          bebux_pnt->BINODE->TIME = delay;
		          bebux_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebux_pnt->BIABL->TIME = delay;
		          bebux_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17, bvl_y_vsp[-6].name.NAME);
		    break;
		  }
		;
    break;}
case 79:
#line 2440 "bvl_bcomp.yac"
{
		struct bvl_expr *expr_pnt;

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = bvl_y_vsp[-1].list.WIDTH;
		expr_pnt->LIST_ABL = bvl_y_vsp[-1].list.LIST_ABL;
		BVL_CNDLST         = addchain (BVL_CNDLST, (char *) expr_pnt);

		expr_pnt           = (bvl_ablstr *)mbkalloc(sizeof(bvl_ablstr));
		expr_pnt->WIDTH    = bvl_y_vsp[-3].list.WIDTH;
		expr_pnt->LIST_ABL = bvl_y_vsp[-3].list.LIST_ABL;
		BVL_VALLST         = addchain (BVL_VALLST, (char *) expr_pnt);
		;
    break;}
case 80:
#line 2458 "bvl_bcomp.yac"
{
		BVL_SLCEXP = bvl_y_vsp[0].list;
		BVL_BDDPNT = NULL;
		;
    break;}
case 81:
#line 2470 "bvl_bcomp.yac"
{
		int             i;
		struct beout   *beout_pnt;
		struct bebus   *bebus_pnt;
		struct bereg   *bereg_pnt;
		struct beaux   *beaux_pnt;
		struct bebux   *bebux_pnt;
		struct chain   *abl_pnt  ;
		unsigned long   delay    ;
		struct bvl_expr expr1    ;
		int             rev_flg  = 0;
		int             left_bnd;
		int             right_bnd;
		int             left;
		int             right;
		int             in_bound;
		int             out_bound;
		int             sig_width;
		int             sig_conf;

		/* ###----------------------------------------------### */
		/*    $10 est une structure, pas un pointeur...		*/
		/*    et c'est bien la le probleme............		*/
		/*    Pour BVL_EMPSTR le champs LIST_ABL doit etre NULL	*/
		/* ###----------------------------------------------### */

                if ((bvl_y_vsp[-1].list.LIST_ABL != NULL) && (bvl_y_vsp[-2].list.TIME != bvl_y_vsp[-1].list.TIME))
                  {
		  bvl_error (80, NULL);
                  }
		expr1      = crtabl (OR , bvl_y_vsp[-2].list , bvl_y_vsp[-1].list, -1, -1);
		expr1.TIME = bvl_y_vsp[-2].list.TIME;

		if (BVL_BDDPNT != one)
		  bvl_error (25, NULL);

		left_bnd  = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_WMXDFN);
		sig_conf  = beh_chktab (dic, bvl_y_vsp[-6].name.NAME, BVL_MODNAM, BVL_SIGDFN);

		left  = bvl_y_vsp[-6].name.LEFT ;
		right = bvl_y_vsp[-6].name.RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  sig_width = right_bnd - left_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 0;
		    in_bound  = right_bnd - right;
		    out_bound = right_bnd - left ;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  else
		    {
		    rev_flg   = 1;
		    in_bound  = right_bnd - left ;
		    out_bound = right_bnd - right;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  }
		else
		  {
		  sig_width = left_bnd - right_bnd + 1;
		  if (left <= right)
		    {
		    rev_flg   = 1;
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  else
		    {
		    rev_flg   = 0;
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, bvl_y_vsp[-6].name.NAME);
		    }
		  }

		if ((out_bound - in_bound + 1) != expr1.WIDTH)
		  bvl_error (35, bvl_y_vsp[-6].name.NAME);

		if (rev_flg == 1)
		  expr1.LIST_ABL = reverse (expr1.LIST_ABL);

		abl_pnt = expr1.LIST_ABL;
		delay   = expr1.TIME    ;

		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		    bvl_error (21, bvl_y_vsp[-6].name.NAME);
		    break;

		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		    if (bvl_y_vsp[-4].valu == BVL_GRDDFN)
		      bvl_error (22, bvl_y_vsp[-6].name.NAME);
		    beout_pnt = (struct beout *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beout_pnt->ABL != NULL)
		            bvl_error (39, beout_pnt->NAME);
		          else
		            {
		            beout_pnt->ABL  = (struct chain *)abl_pnt->DATA;
		            beout_pnt->TIME = delay;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beout_pnt = beout_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bebus_pnt = (struct bebus *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebus_pnt->BINODE = beh_addbinode (bebus_pnt->BINODE,
		                                             NULL, NULL);
		          bebus_pnt->BINODE->TIME = delay;
		          bebus_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bebus_pnt->BIABL  = beh_addbiabl  (bebus_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebus_pnt->BIABL->TIME = delay;
		          bebus_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebus_pnt = bebus_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_BITDFN + BVL_NORDFN):
		    if (bvl_y_vsp[-4].valu == BVL_GRDDFN)
		      bvl_error (22, bvl_y_vsp[-6].name.NAME);
		    beaux_pnt = (struct beaux *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          if (beaux_pnt->ABL != NULL)
		            bvl_error (39, beaux_pnt->NAME);
		          else
		           {
		            beaux_pnt->ABL  = (struct chain *) abl_pnt->DATA;
		            beaux_pnt->TIME = delay;
		            beaux_pnt->FLAG = bvl_y_vsp[-3].valu   ;
		            }
		          abl_pnt = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        beaux_pnt = beaux_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_RBIDFN + BVL_REGDFN):
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bereg_pnt = (struct bereg *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bereg_pnt->BINODE = beh_addbinode (bereg_pnt->BINODE,
		                                             NULL, NULL);
		          bereg_pnt->BINODE->TIME = delay;
		          bereg_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bereg_pnt->BIABL  = beh_addbiabl  (bereg_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bereg_pnt->BIABL->TIME = delay;
		          bereg_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bereg_pnt = bereg_pnt->NEXT;
		        }
		      }
		    break;

		  case (BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_WORDFN + BVL_BUSDFN) :
		    if ((bvl_y_vsp[-4].valu != BVL_GRDDFN) || (BVL_GRDLST == NULL))
		      bvl_error (23, bvl_y_vsp[-6].name.NAME);
		    bebux_pnt = (struct bebux *)
		                beh_chktab (dic,bvl_y_vsp[-6].name.NAME,BVL_MODNAM,BVL_PNTDFN);
		    if (BVL_ERRFLG == 0)
		      {
		      for (i=0 ; i<sig_width ; i++)
		        {
		        if (i >= in_bound)
		          {
		          bebux_pnt->BINODE = beh_addbinode (bebux_pnt->BINODE,
		                                             NULL, NULL);
		          bebux_pnt->BINODE->TIME = delay;
		          bebux_pnt->BINODE->FLAG = bvl_y_vsp[-3].valu   ;

		          bebux_pnt->BIABL  = beh_addbiabl  (bebux_pnt->BIABL,
		                                             BVL_LBLNAM,
		                                             copyExpr(BVL_GRDLST->DATA) ,
		                                             abl_pnt->DATA);
		          bebux_pnt->BIABL->TIME = delay;
		          bebux_pnt->BIABL->FLAG = bvl_y_vsp[-3].valu   ;
		          abl_pnt                = abl_pnt->NEXT;
		          }
		        if (i >= out_bound)
		          break;
		        bebux_pnt = bebux_pnt->NEXT;
		        }
		      }
		    break;

		  default :
		    bvl_error (17, bvl_y_vsp[-6].name.NAME);
		    break;
		  }
		;
    break;}
case 82:
#line 2731 "bvl_bcomp.yac"
{ bvl_y_val.list = BVL_EMPSTR; ;
    break;}
case 83:
#line 2735 "bvl_bcomp.yac"
{
		/* ###----------------------------------------------### */
		/*    $9 est une structure, pas un pointeur...		*/
		/*    et c'est bien la le probleme............		*/
		/*    Pour BVL_EMPSTR le champs LIST_ABL doit etre NULL	*/
		/* ###----------------------------------------------### */

		if ((bvl_y_vsp[-2].list.LIST_ABL != NULL) && (bvl_y_vsp[-2].list.TIME != bvl_y_vsp[0].list.TIME))
                  {
		  bvl_error (80, NULL);
                  }

		bvl_y_val.list      = crtabl (OR, bvl_y_vsp[-2].list, bvl_y_vsp[0].list, -1, -1);
		bvl_y_val.list.TIME = bvl_y_vsp[0].list.TIME;
		;
    break;}
case 84:
#line 2756 "bvl_bcomp.yac"
{
		struct bvl_expr expr1;

		bvl_select (&expr1, BVL_NM1LST, &BVL_BDDPNT, BVL_SLCEXP);
		freechain  (BVL_NM1LST);
		BVL_NM1LST = NULL;

		bvl_y_val.list      = crtabl (ANDM, bvl_y_vsp[-2].list, expr1, -1, -1);
		bvl_y_val.list.TIME = bvl_y_vsp[-2].list.TIME;
		;
    break;}
case 85:
#line 2770 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 86:
#line 2776 "bvl_bcomp.yac"
{
		bvl_y_val.list      = bvl_y_vsp[-1].list;
		bvl_y_val.list.TIME = bvl_y_vsp[0].valu;
		;
    break;}
case 87:
#line 2784 "bvl_bcomp.yac"
{ bvl_y_val.valu = 0; ;
    break;}
case 88:
#line 2787 "bvl_bcomp.yac"
{ bvl_y_val.valu = bvl_y_vsp[0].valu; ;
    break;}
case 89:
#line 2793 "bvl_bcomp.yac"
{
		unsigned int dly;

		/* ###----------------------------------------------### */
		/*    if the delay is not null unset the 'zero delay'	*/
		/* flag of the description				*/
		/* ###----------------------------------------------### */

		dly = bvl_y_vsp[-1].valu * bvl_y_vsp[0].flov;
		if (dly != 0)
		  BVL_BEFPNT->FLAG &= ~BEH_FIG_ZERODELAY;

		bvl_y_val.valu = dly;
		;
    break;}
case 90:
#line 2811 "bvl_bcomp.yac"
{ bvl_y_val.flov = BVL_CNVFS ; ;
    break;}
case 91:
#line 2813 "bvl_bcomp.yac"
{ bvl_y_val.flov = BVL_CNVPS ; ;
    break;}
case 92:
#line 2815 "bvl_bcomp.yac"
{ bvl_y_val.flov = BVL_CNVNS ; ;
    break;}
case 93:
#line 2817 "bvl_bcomp.yac"
{ bvl_y_val.flov = BVL_CNVUS ; ;
    break;}
case 94:
#line 2819 "bvl_bcomp.yac"
{ bvl_y_val.flov = BVL_CNVMS ; ;
    break;}
case 95:
#line 2824 "bvl_bcomp.yac"
{ BVL_NM1LST = addchain (NULL, bvl_y_vsp[0].text); ;
    break;}
case 96:
#line 2826 "bvl_bcomp.yac"
{ bvl_y_errok; ;
    break;}
case 98:
#line 2834 "bvl_bcomp.yac"
{
		if (bvl_y_vsp[0].text == "others")
		  bvl_error (30, NULL);
		BVL_NM1LST = addchain (BVL_NM1LST, bvl_y_vsp[0].text);
		;
    break;}
case 99:
#line 2843 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 100:
#line 2845 "bvl_bcomp.yac"
{ bvl_y_val.text = "others"; ;
    break;}
case 101:
#line 2847 "bvl_bcomp.yac"
{
		char           *val;
		char            val2[256];
		int             left;
		int             right;
		int             in_bound;
		int             out_bound;
		int             left_bnd;
		int             right_bnd;
		int             sig_conf;

		strcpy (val2, "B\"");
		sig_conf = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_SIGDFN);
		val      = (char *) beh_chktab (dic, bvl_y_vsp[0].name.NAME, NULL, BVL_PNTDFN);
		if (sig_conf == 0)
		  bvl_error (17, bvl_y_vsp[0].name.NAME);
		else
		  {
		  if (sig_conf != BVL_CSTDFN)
		    bvl_error (76, bvl_y_vsp[0].name.NAME);
		  }

		left_bnd  = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_WMXDFN);

		left  = bvl_y_vsp[0].name.LEFT;
		right = bvl_y_vsp[0].name.RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound = left - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  else
		    {
		    in_bound = left - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound = right - left_bnd;
		    out_bound = left - left_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  else
		    {
		    in_bound = right - right_bnd;
		    out_bound = left - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  }

		tobin (&val2[2], val, in_bound, out_bound);
		strcat (val2, "\"");
		bvl_y_val.text = namealloc (val2);
		;
    break;}
case 102:
#line 2918 "bvl_bcomp.yac"
{ bvl_y_val.text = NULL; ;
    break;}
case 103:
#line 2921 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 104:
#line 2926 "bvl_bcomp.yac"
{ bvl_y_val.valu = 'E'; ;
    break;}
case 105:
#line 2929 "bvl_bcomp.yac"
{ bvl_y_val.valu = bvl_y_vsp[0].valu; ;
    break;}
case 106:
#line 2934 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 107:
#line 2939 "bvl_bcomp.yac"
{ bvl_y_val.valu = 'E'; ;
    break;}
case 108:
#line 2941 "bvl_bcomp.yac"
{ bvl_y_val.valu = 'W'; ;
    break;}
case 109:
#line 2946 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 110:
#line 2948 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 111:
#line 2950 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 112:
#line 2952 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 113:
#line 2959 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (AND , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 114:
#line 2963 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (AND , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 115:
#line 2970 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (OR , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 116:
#line 2974 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (OR , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 117:
#line 2979 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 118:
#line 2983 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (NAND , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 119:
#line 2987 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (NOR , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 120:
#line 2995 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (XOR , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 121:
#line 2999 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (XOR , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 122:
#line 3004 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 123:
#line 3008 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (bvl_y_vsp[-1].valu , bvl_y_vsp[-2].list , bvl_y_vsp[0].list , -1, -1); ;
    break;}
case 124:
#line 3013 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 125:
#line 3018 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 126:
#line 3022 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (CONC, bvl_y_vsp[-2].list, bvl_y_vsp[0].list, -1, -1); ;
    break;}
case 127:
#line 3028 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 128:
#line 3033 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 129:
#line 3036 "bvl_bcomp.yac"
{ bvl_y_val.list = crtabl (NOT, bvl_y_vsp[0].list, BVL_EMPSTR, -1, -1); ;
    break;}
case 130:
#line 3041 "bvl_bcomp.yac"
{
		struct bvl_expr expr1;
		expr1.IDENT = bvl_y_vsp[0].text;
		bvl_y_val.list = crtabl (NOPS, expr1, BVL_EMPSTR, -1, -1);
		;
    break;}
case 131:
#line 3047 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[0].list; ;
    break;}
case 132:
#line 3049 "bvl_bcomp.yac"
{
		struct bvl_expr expr1;
		int             left;
		int             right;
		int             left_bnd;
		int             right_bnd;
		int             in_bound;
		int             out_bound;
		int             sig_conf;

		sig_conf = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		  case (BVL_CSTDFN):
		    break;
		  case (BVL_OCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_OCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_OCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		    bvl_error (26, bvl_y_vsp[0].name.NAME);
		    break;
		  default :
		    bvl_error (17, bvl_y_vsp[0].name.NAME);
		    break;
		  }

		left_bnd  = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_WMNDFN);
		right_bnd = beh_chktab (dic, bvl_y_vsp[0].name.NAME, BVL_MODNAM, BVL_WMXDFN);

		left  = bvl_y_vsp[0].name.LEFT;
		right = bvl_y_vsp[0].name.RIGHT;

		if (left_bnd <= right_bnd)
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - left_bnd;
		    out_bound = right - left_bnd;
		    if ((left < left_bnd) || (right > right_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  else
		    {
		    in_bound  = right - left_bnd;
		    out_bound = left  - left_bnd;
		    if ((left > right_bnd) || (right < left_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  }
		else
		  {
		  if (left <= right)
		    {
		    in_bound  = left  - right_bnd;
		    out_bound = right - right_bnd;
		    if ((left < right_bnd) || (right > left_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  else
		    {
		    in_bound  = right - right_bnd;
		    out_bound = left  - right_bnd;
		    if ((left > left_bnd) || (right < right_bnd))
		      bvl_error (36, bvl_y_vsp[0].name.NAME);
		    }
		  }

		if (sig_conf != BVL_CSTDFN)
		  {
		  expr1.IDENT = bvl_y_vsp[0].name.NAME;
		  if(bvl_y_vsp[0].name.FLAG == 'X')
		    {
		    expr1 = crtabl (NOPI  , expr1, BVL_EMPSTR, left, right);
		    bvl_y_val.list    = crtabl (STABLE, expr1, BVL_EMPSTR, left, right);
		    }
		  else 
		    bvl_y_val.list    = crtabl (NOPI  , expr1, BVL_EMPSTR, left, right);
		  }
		else
		  {
		  expr1.IDENT = (char *)beh_chktab(dic,bvl_y_vsp[0].name.NAME,NULL,BVL_PNTDFN);
		  bvl_y_val.list = crtabl (NOPS,expr1,BVL_EMPSTR,in_bound,out_bound);
		  }
		;
    break;}
case 133:
#line 3144 "bvl_bcomp.yac"
{ bvl_y_val.valu = EQ; ;
    break;}
case 134:
#line 3146 "bvl_bcomp.yac"
{ bvl_y_val.valu = NE; ;
    break;}
case 135:
#line 3151 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 136:
#line 3153 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 137:
#line 3155 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 138:
#line 3162 "bvl_bcomp.yac"
{ bvl_y_val.list = bvl_y_vsp[-1].list; ;
    break;}
case 139:
#line 3167 "bvl_bcomp.yac"
{
		bvl_y_val.name.NAME  = bvl_y_vsp[0].text;
		bvl_y_val.name.LEFT  = beh_chktab (dic, bvl_y_vsp[0].text, BVL_MODNAM, BVL_WMNDFN);
		bvl_y_val.name.RIGHT = beh_chktab (dic, bvl_y_vsp[0].text, BVL_MODNAM, BVL_WMXDFN);
		;
    break;}
case 140:
#line 3173 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[0].name; ;
    break;}
case 141:
#line 3175 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[0].name; ;
    break;}
case 142:
#line 3177 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[0].name; ;
    break;}
case 143:
#line 3185 "bvl_bcomp.yac"
{
		bvl_y_val.name.NAME  = bvl_y_vsp[-3].text;
		bvl_y_val.name.LEFT  = bvl_y_vsp[-1].valu;
		bvl_y_val.name.RIGHT = bvl_y_vsp[-1].valu;
		;
    break;}
case 144:
#line 3199 "bvl_bcomp.yac"
{
		if (((bvl_y_vsp[-1].valu > bvl_y_vsp[-3].valu) && (bvl_y_vsp[-2].valu != BVL_UPTDFN)) ||
		    ((bvl_y_vsp[-1].valu < bvl_y_vsp[-3].valu) && (bvl_y_vsp[-2].valu != BVL_DWTDFN)))
		  bvl_error (32, bvl_y_vsp[-5].text);

		bvl_y_val.name.NAME  = bvl_y_vsp[-5].text;
		bvl_y_val.name.LEFT  = bvl_y_vsp[-3].valu;
		bvl_y_val.name.RIGHT = bvl_y_vsp[-1].valu;
		;
    break;}
case 145:
#line 3214 "bvl_bcomp.yac"
{
		char             extname [100];
		char            *lclname      ;
		int              sig_conf     ;
		struct bvl_expr  expr1        ;
		struct bvl_expr  expr2        ;
		struct chain    *ptabl        ;

		sig_conf = beh_chktab (dic, bvl_y_vsp[-2].text, BVL_MODNAM, BVL_SIGDFN);
		switch (sig_conf)
		  {
		  case (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_BITDFN + BVL_NORDFN) :
		  case (BVL_BCNDFN + BVL_MUXDFN + BVL_BUSDFN) :
		  case (BVL_BCNDFN + BVL_WORDFN + BVL_BUSDFN) :
		  case (BVL_BITDFN + BVL_NORDFN):
		  case (BVL_MUXDFN + BVL_BUSDFN):
		  case (BVL_WORDFN + BVL_BUSDFN):
		  case (BVL_RBIDFN + BVL_REGDFN):
		    break;
		  default :
		    bvl_error (79, bvl_y_vsp[-2].text);
		  }

		if (beh_chktab (dic, bvl_y_vsp[-2].text, BVL_MODNAM, BVL_WMNDFN) != -1)
		  bvl_error (79, bvl_y_vsp[-2].text);

		sprintf (extname, "%s'delayed", bvl_y_vsp[-2].text);
		lclname = namealloc (extname);

		if (BVL_ERRFLG == 0)
		  {
		  if (beh_chktab (dic, bvl_y_vsp[-2].text, BVL_MODNAM, BVL_STBDFN) == 0)
		    {
		    expr1.IDENT = bvl_y_vsp[-2].text;
		    expr1.WIDTH  = 1;
		    expr2 = crtabl (NOPI, expr1, BVL_EMPSTR, -1, -1);
		    ptabl = expr2.LIST_ABL->DATA;

		    if (BVL_AUXMOD == 1)
		      BVL_BEFPNT->BERIN=beh_addberin(BVL_BEFPNT->BERIN,lclname);

		    BVL_BEFPNT->BEDLY = beh_addbeaux(BVL_BEFPNT->BEDLY,lclname,
		                                     ptabl, NULL);
		    beh_addtab (dic, bvl_y_vsp[-2].text     , BVL_MODNAM, BVL_STBDFN, 1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_WMNDFN, -1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_WMXDFN, -1);
		    beh_addtab (dic, lclname, BVL_MODNAM, BVL_SIGDFN,
		                (BVL_ICNDFN + BVL_BITDFN + BVL_NORDFN));
		    }
		  }
		BVL_BEFPNT->TYPE |= BEH_STABLE;
		bvl_y_val.name.NAME  = bvl_y_vsp[-2].text ;
		bvl_y_val.name.LEFT  = -1 ;
		bvl_y_val.name.RIGHT = -1 ;
		bvl_y_val.name.FLAG  = 'X';

		;
    break;}
case 147:
#line 3280 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = BIT; bvl_y_val.dble.FLAG = 'S'; ;
    break;}
case 148:
#line 3282 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = WOR_BIT; bvl_y_val.dble.FLAG = 'S'; ;
    break;}
case 149:
#line 3284 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = MUX_BIT; bvl_y_val.dble.FLAG = 'S'; ;
    break;}
case 150:
#line 3286 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = BIT; bvl_y_val.dble.FLAG = 'A'; ;
    break;}
case 151:
#line 3288 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = WOR_BIT; bvl_y_val.dble.FLAG = 'A'; ;
    break;}
case 152:
#line 3290 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = MUX_BIT; bvl_y_val.dble.FLAG = 'A'; ;
    break;}
case 153:
#line 3292 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = REG_BIT; bvl_y_val.dble.FLAG = 'S'; ;
    break;}
case 154:
#line 3294 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = REG_BIT; bvl_y_val.dble.FLAG = 'A'; ;
    break;}
case 155:
#line 3296 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = NATURAL; bvl_y_val.dble.FLAG = 'S'; ;
    break;}
case 156:
#line 3298 "bvl_bcomp.yac"
{ bvl_y_val.dble.VALU = NATURAL; bvl_y_val.dble.FLAG = 'A'; ;
    break;}
case 157:
#line 3303 "bvl_bcomp.yac"
{ BVL_NM1LST = addchain (BVL_NM1LST, bvl_y_vsp[0].text); ;
    break;}
case 160:
#line 3312 "bvl_bcomp.yac"
{ BVL_NM1LST = addchain (BVL_NM1LST, bvl_y_vsp[0].text); ;
    break;}
case 161:
#line 3317 "bvl_bcomp.yac"
{ bvl_y_val.text = NULL; ;
    break;}
case 162:
#line 3319 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 163:
#line 3324 "bvl_bcomp.yac"
{ bvl_y_val.text = NULL; ;
    break;}
case 164:
#line 3326 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 165:
#line 3333 "bvl_bcomp.yac"
{ bvl_y_val.text = (char *)bvl_y_vsp[-1].list.LIST_ABL->DATA; ;
    break;}
case 166:
#line 3338 "bvl_bcomp.yac"
{ bvl_y_val.valu = BEH_ASG_INERTIAL ; ;
    break;}
case 167:
#line 3340 "bvl_bcomp.yac"
{ bvl_y_val.valu = BEH_ASG_TRANSPORT; ;
    break;}
case 168:
#line 3345 "bvl_bcomp.yac"
{ bvl_y_val.valu = BVL_UNGDFN ; ;
    break;}
case 169:
#line 3347 "bvl_bcomp.yac"
{ bvl_y_val.valu = BVL_GRDDFN; ;
    break;}
case 170:
#line 3352 "bvl_bcomp.yac"
{ bvl_y_val.text = NULL; ;
    break;}
case 171:
#line 3354 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 172:
#line 3359 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 173:
#line 3364 "bvl_bcomp.yac"
{ bvl_y_val.name = bvl_y_vsp[0].name; ;
    break;}
case 174:
#line 3370 "bvl_bcomp.yac"
{
		BVL_LBLNAM = bvl_y_vsp[-1].text;
		bvl_y_val.text = bvl_y_vsp[-1].text;
		;
    break;}
case 175:
#line 3378 "bvl_bcomp.yac"
{ bvl_y_val.text = bvl_y_vsp[0].text; ;
    break;}
case 176:
#line 3383 "bvl_bcomp.yac"
{ bvl_y_val.valu = atoi (bvl_y_vsp[0].text); ;
    break;}
case 177:
#line 3388 "bvl_bcomp.yac"
{ bvl_y_errok; ;
    break;}
case 178:
#line 3393 "bvl_bcomp.yac"
{ bvl_y_errok; ;
    break;}
case 179:
#line 3398 "bvl_bcomp.yac"
{ bvl_y_errok; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/freeware/share/bison.simple"

  bvl_y_vsp -= bvl_y_len;
  bvl_y_ssp -= bvl_y_len;
#ifdef BVL_Y_LSP_NEEDED
  bvl_y_lsp -= bvl_y_len;
#endif

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    {
      short *ssp1 = bvl_y_ss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != bvl_y_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++bvl_y_vsp = bvl_y_val;

#ifdef BVL_Y_LSP_NEEDED
  bvl_y_lsp++;
  if (bvl_y_len == 0)
    {
      bvl_y_lsp->first_line = bvl_y_lloc.first_line;
      bvl_y_lsp->first_column = bvl_y_lloc.first_column;
      bvl_y_lsp->last_line = (bvl_y_lsp-1)->last_line;
      bvl_y_lsp->last_column = (bvl_y_lsp-1)->last_column;
      bvl_y_lsp->text = 0;
    }
  else
    {
      bvl_y_lsp->last_line = (bvl_y_lsp+bvl_y_len-1)->last_line;
      bvl_y_lsp->last_column = (bvl_y_lsp+bvl_y_len-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  bvl_y_n = bvl_y_r1[bvl_y_n];

  bvl_y_state = bvl_y_pgoto[bvl_y_n - BVL_Y_NTBASE] + *bvl_y_ssp;
  if (bvl_y_state >= 0 && bvl_y_state <= BVL_Y_LAST && bvl_y_check[bvl_y_state] == *bvl_y_ssp)
    bvl_y_state = bvl_y_table[bvl_y_state];
  else
    bvl_y_state = bvl_y_defgoto[bvl_y_n - BVL_Y_NTBASE];

  goto bvl_y_newstate;

bvl_y_errlab:   /* here on detecting error */

  if (! bvl_y_errstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++bvl_y_nerrs;

#ifdef BVL_Y_ERROR_VERBOSE
      bvl_y_n = bvl_y_pact[bvl_y_state];

      if (bvl_y_n > BVL_Y_FLAG && bvl_y_n < BVL_Y_LAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -bvl_y_n if nec to avoid negative indexes in bvl_y_check.  */
	  for (x = (bvl_y_n < 0 ? -bvl_y_n : 0);
	       x < (sizeof(bvl_y_tname) / sizeof(char *)); x++)
	    if (bvl_y_check[x + bvl_y_n] == x)
	      size += strlen(bvl_y_tname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (bvl_y_n < 0 ? -bvl_y_n : 0);
		       x < (sizeof(bvl_y_tname) / sizeof(char *)); x++)
		    if (bvl_y_check[x + bvl_y_n] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, bvl_y_tname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      bvl_y_error(msg);
	      free(msg);
	    }
	  else
	    bvl_y_error ("parse error; also virtual memory exceeded");
	}
      else
#endif /* BVL_Y_ERROR_VERBOSE */
	bvl_y_error("parse error");
    }

  goto bvl_y_errlab1;
bvl_y_errlab1:   /* here on error raised explicitly by an action */

  if (bvl_y_errstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (bvl_y_char == BVL_Y_EOF)
	BVL_Y_ABORT;

#if BVL_Y_DEBUG != 0
      if (bvl_y_debug)
	fprintf(stderr, "Discarding token %d (%s).\n", bvl_y_char, bvl_y_tname[bvl_y_char1]);
#endif

      bvl_y_char = BVL_Y_EMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  bvl_y_errstatus = 3;		/* Each real token shifted decrements this */

  goto bvl_y_errhandle;

bvl_y_errdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  bvl_y_n = bvl_y_defact[bvl_y_state];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (bvl_y_n) goto bvl_y_default;
#endif

bvl_y_errpop:   /* pop the current state because it cannot handle the error token */

  if (bvl_y_ssp == bvl_y_ss) BVL_Y_ABORT;
  bvl_y_vsp--;
  bvl_y_state = *--bvl_y_ssp;
#ifdef BVL_Y_LSP_NEEDED
  bvl_y_lsp--;
#endif

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    {
      short *ssp1 = bvl_y_ss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != bvl_y_ssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

bvl_y_errhandle:

  bvl_y_n = bvl_y_pact[bvl_y_state];
  if (bvl_y_n == BVL_Y_FLAG)
    goto bvl_y_errdefault;

  bvl_y_n += BVL_Y_TERROR;
  if (bvl_y_n < 0 || bvl_y_n > BVL_Y_LAST || bvl_y_check[bvl_y_n] != BVL_Y_TERROR)
    goto bvl_y_errdefault;

  bvl_y_n = bvl_y_table[bvl_y_n];
  if (bvl_y_n < 0)
    {
      if (bvl_y_n == BVL_Y_FLAG)
	goto bvl_y_errpop;
      bvl_y_n = -bvl_y_n;
      goto bvl_y_reduce;
    }
  else if (bvl_y_n == 0)
    goto bvl_y_errpop;

  if (bvl_y_n == BVL_Y_FINAL)
    BVL_Y_ACCEPT;

#if BVL_Y_DEBUG != 0
  if (bvl_y_debug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++bvl_y_vsp = bvl_y_lval;
#ifdef BVL_Y_LSP_NEEDED
  *++bvl_y_lsp = bvl_y_lloc;
#endif

  bvl_y_state = bvl_y_n;
  goto bvl_y_newstate;

 bvl_y_acceptlab:
  /* BVL_Y_ACCEPT comes here.  */
  if (bvl_y_free_stacks)
    {
      free (bvl_y_ss);
      free (bvl_y_vs);
#ifdef BVL_Y_LSP_NEEDED
      free (bvl_y_ls);
#endif
    }
  return 0;

 bvl_y_abortlab:
  /* BVL_Y_ABORT comes here.  */
  if (bvl_y_free_stacks)
    {
      free (bvl_y_ss);
      free (bvl_y_vs);
#ifdef BVL_Y_LSP_NEEDED
      free (bvl_y_ls);
#endif
    }
  return 1;
}
#line 3400 "bvl_bcomp.yac"

