/*
 * $Author: alliance $
 * $Id: fpm_net.c,v 1.1.1.1 1998/10/21 16:32:41 alliance Exp $
 * $Date: 1998/10/21 16:32:41 $
 */
/*
 * $Log: fpm_net.c,v $
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*            void fpnetwork_optimize( fpnetwork_t *Network )           */
/* -------------------------------------------------------------------- */
/*	Dans le package bdd utilise, les variables sont regroupees en	*/
/* bddvartree. Les bddvartree forment une hierarchie, leur but etant de	*/
/* controler les ordres possibles durant la phase de reordonnancement.	*/
/*                                                                      */
/*	Par exemple, un bddvartree contenant les variables d'index 0 a	*/
/* 3 peut contenir 2 sub-bddvartree, le premier avec les variables	*/
/* d'index 0 et 1, et le second avec les variables 2 et 3.		*/
/*                                                                      */
/* bddvartree {								*/
/*     first	    = 0;						*/
/*     last	    = 3;						*/
/*     reorder	    = true | flase;					*/
/*     number_child = 2;						*/
/*     child        = [							*/
/*         bddvartree {							*/
/*             first        = 0;					*/
/*             last         = 1;					*/
/*             reorder      = true;					*/
/*             number_child = 0;					*/
/*             child        = [];					*/
/*         };								*/
/*         bddvartree {							*/
/*             first        = 2;					*/
/*             last         = 3;					*/
/*             reorder      = true;					*/
/*             number_child = 0;					*/
/*             child        = [];					*/
/*         };								*/
/*     ];								*/
/* };									*/
/*									*/
/*	Le reordonnancement d'un bddvartree se decompose de la facon	*/
/* suivante:								*/
/* - On reordonne dans un premier temps les bddvartree de plus haut	*/
/*   niveau (on commence par bddsystem->VAR_TREE).			*/
/* - une fois qu'un bddvartree a ete reordonne, on s'occupe alors de	*/
/*   ses CHILD.								*/
/* Le reordonnancement d'un bddvartree consiste a entrelacer ses CHILDs	*/
/* a la maniere du sift. Pour cela, on utilise la fonction		*/
/* swapbddvartree( System, VarTree, Child ) qui swap les bddvartree	*/
/* Child et Child + 1 de VarTree.					*/
/*									*/
/*	On sift donc tous les Child d'un bddvartree, en commencant par	*/
/* les plus gros (la fonction bddvartreenode( System, VarTree )		*/
/* retourne le nombre de noeuds bddnode associes a un bddvartree).	*/
/*	Pour plus d'info, voir dans ../bdd/bddreorder.c (reordersift)	*/
/*									*/
/*	De plus, pour gagner en vitesse, on ne recalcule les cout que	*/
/* pour les sorties depedant de la variable swappee.			*/
/*----------------------------------------------------------------------*/

void
fpnetwork_optimize( Network )
	fpnetwork_t *Network;
{
}


/*----------------------------------------------------------------------*/
/*             void fpnetwork_depend( fpnetwork_t *Network )            */
/* -------------------------------------------------------------------- */
/*	Met a jour les listes de dependances des toutes les fpinput_t	*/
/*----------------------------------------------------------------------*/

void
fpnetwork_depend( Network )
	fpnetwork_t *Network;
{
	bflmapnode_t *First;
	bflmapnode_t *Last;

	First = bflmapbegin( Network->MAP_OUTPUT );
	Last  = bflmapend( Network->MAP_OUTPUT );
}

